// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// AddAlertRuleReader is a Reader for the AddAlertRule structure.
type AddAlertRuleReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddAlertRuleReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddAlertRuleOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddAlertRuleTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddAlertRuleDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddAlertRuleOK creates a AddAlertRuleOK with default headers values
func NewAddAlertRuleOK() *AddAlertRuleOK {
	return &AddAlertRuleOK{}
}

/* AddAlertRuleOK describes a response with status code 200, with default header values.

successful operation
*/
type AddAlertRuleOK struct {
	Payload *models.AlertRule
}

func (o *AddAlertRuleOK) Error() string {
	return fmt.Sprintf("[POST /setting/alert/rules][%d] addAlertRuleOK  %+v", 200, o.Payload)
}
func (o *AddAlertRuleOK) GetPayload() *models.AlertRule {
	return o.Payload
}

func (o *AddAlertRuleOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.AlertRule)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddAlertRuleTooManyRequests creates a AddAlertRuleTooManyRequests with default headers values
func NewAddAlertRuleTooManyRequests() *AddAlertRuleTooManyRequests {
	return &AddAlertRuleTooManyRequests{}
}

/* AddAlertRuleTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddAlertRuleTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *AddAlertRuleTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /setting/alert/rules][%d] addAlertRuleTooManyRequests ", 429)
}

func (o *AddAlertRuleTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddAlertRuleDefault creates a AddAlertRuleDefault with default headers values
func NewAddAlertRuleDefault(code int) *AddAlertRuleDefault {
	return &AddAlertRuleDefault{
		_statusCode: code,
	}
}

/* AddAlertRuleDefault describes a response with status code -1, with default header values.

Error
*/
type AddAlertRuleDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the add alert rule default response
func (o *AddAlertRuleDefault) Code() int {
	return o._statusCode
}

func (o *AddAlertRuleDefault) Error() string {
	return fmt.Sprintf("[POST /setting/alert/rules][%d] addAlertRule default  %+v", o._statusCode, o.Payload)
}
func (o *AddAlertRuleDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddAlertRuleDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
