// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// AddCollectorReader is a Reader for the AddCollector structure.
type AddCollectorReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddCollectorReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddCollectorOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddCollectorTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddCollectorDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddCollectorOK creates a AddCollectorOK with default headers values
func NewAddCollectorOK() *AddCollectorOK {
	return &AddCollectorOK{}
}

/* AddCollectorOK describes a response with status code 200, with default header values.

successful operation
*/
type AddCollectorOK struct {
	Payload *models.Collector
}

func (o *AddCollectorOK) Error() string {
	return fmt.Sprintf("[POST /setting/collector/collectors][%d] addCollectorOK  %+v", 200, o.Payload)
}
func (o *AddCollectorOK) GetPayload() *models.Collector {
	return o.Payload
}

func (o *AddCollectorOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Collector)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddCollectorTooManyRequests creates a AddCollectorTooManyRequests with default headers values
func NewAddCollectorTooManyRequests() *AddCollectorTooManyRequests {
	return &AddCollectorTooManyRequests{}
}

/* AddCollectorTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddCollectorTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *AddCollectorTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /setting/collector/collectors][%d] addCollectorTooManyRequests ", 429)
}

func (o *AddCollectorTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddCollectorDefault creates a AddCollectorDefault with default headers values
func NewAddCollectorDefault(code int) *AddCollectorDefault {
	return &AddCollectorDefault{
		_statusCode: code,
	}
}

/* AddCollectorDefault describes a response with status code -1, with default header values.

Error
*/
type AddCollectorDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the add collector default response
func (o *AddCollectorDefault) Code() int {
	return o._statusCode
}

func (o *AddCollectorDefault) Error() string {
	return fmt.Sprintf("[POST /setting/collector/collectors][%d] addCollector default  %+v", o._statusCode, o.Payload)
}
func (o *AddCollectorDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddCollectorDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
