// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// AddDatasourceByIDReader is a Reader for the AddDatasourceByID structure.
type AddDatasourceByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddDatasourceByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddDatasourceByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddDatasourceByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddDatasourceByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddDatasourceByIDOK creates a AddDatasourceByIDOK with default headers values
func NewAddDatasourceByIDOK() *AddDatasourceByIDOK {
	return &AddDatasourceByIDOK{}
}

/* AddDatasourceByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type AddDatasourceByIDOK struct {
	Payload *models.DataSource
}

func (o *AddDatasourceByIDOK) Error() string {
	return fmt.Sprintf("[POST /setting/datasources][%d] addDatasourceByIdOK  %+v", 200, o.Payload)
}
func (o *AddDatasourceByIDOK) GetPayload() *models.DataSource {
	return o.Payload
}

func (o *AddDatasourceByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DataSource)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddDatasourceByIDTooManyRequests creates a AddDatasourceByIDTooManyRequests with default headers values
func NewAddDatasourceByIDTooManyRequests() *AddDatasourceByIDTooManyRequests {
	return &AddDatasourceByIDTooManyRequests{}
}

/* AddDatasourceByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddDatasourceByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *AddDatasourceByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /setting/datasources][%d] addDatasourceByIdTooManyRequests ", 429)
}

func (o *AddDatasourceByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddDatasourceByIDDefault creates a AddDatasourceByIDDefault with default headers values
func NewAddDatasourceByIDDefault(code int) *AddDatasourceByIDDefault {
	return &AddDatasourceByIDDefault{
		_statusCode: code,
	}
}

/* AddDatasourceByIDDefault describes a response with status code -1, with default header values.

Error
*/
type AddDatasourceByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the add datasource by Id default response
func (o *AddDatasourceByIDDefault) Code() int {
	return o._statusCode
}

func (o *AddDatasourceByIDDefault) Error() string {
	return fmt.Sprintf("[POST /setting/datasources][%d] addDatasourceById default  %+v", o._statusCode, o.Payload)
}
func (o *AddDatasourceByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddDatasourceByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
