// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// AddDeviceDatasourceInstanceGroupReader is a Reader for the AddDeviceDatasourceInstanceGroup structure.
type AddDeviceDatasourceInstanceGroupReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddDeviceDatasourceInstanceGroupReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddDeviceDatasourceInstanceGroupOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddDeviceDatasourceInstanceGroupTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddDeviceDatasourceInstanceGroupDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddDeviceDatasourceInstanceGroupOK creates a AddDeviceDatasourceInstanceGroupOK with default headers values
func NewAddDeviceDatasourceInstanceGroupOK() *AddDeviceDatasourceInstanceGroupOK {
	return &AddDeviceDatasourceInstanceGroupOK{}
}

/* AddDeviceDatasourceInstanceGroupOK describes a response with status code 200, with default header values.

successful operation
*/
type AddDeviceDatasourceInstanceGroupOK struct {
	Payload *models.DeviceDataSourceInstanceGroup
}

func (o *AddDeviceDatasourceInstanceGroupOK) Error() string {
	return fmt.Sprintf("[POST /device/devices/{deviceId}/devicedatasources/{deviceDsId}/groups][%d] addDeviceDatasourceInstanceGroupOK  %+v", 200, o.Payload)
}
func (o *AddDeviceDatasourceInstanceGroupOK) GetPayload() *models.DeviceDataSourceInstanceGroup {
	return o.Payload
}

func (o *AddDeviceDatasourceInstanceGroupOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DeviceDataSourceInstanceGroup)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddDeviceDatasourceInstanceGroupTooManyRequests creates a AddDeviceDatasourceInstanceGroupTooManyRequests with default headers values
func NewAddDeviceDatasourceInstanceGroupTooManyRequests() *AddDeviceDatasourceInstanceGroupTooManyRequests {
	return &AddDeviceDatasourceInstanceGroupTooManyRequests{}
}

/* AddDeviceDatasourceInstanceGroupTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddDeviceDatasourceInstanceGroupTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *AddDeviceDatasourceInstanceGroupTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /device/devices/{deviceId}/devicedatasources/{deviceDsId}/groups][%d] addDeviceDatasourceInstanceGroupTooManyRequests ", 429)
}

func (o *AddDeviceDatasourceInstanceGroupTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddDeviceDatasourceInstanceGroupDefault creates a AddDeviceDatasourceInstanceGroupDefault with default headers values
func NewAddDeviceDatasourceInstanceGroupDefault(code int) *AddDeviceDatasourceInstanceGroupDefault {
	return &AddDeviceDatasourceInstanceGroupDefault{
		_statusCode: code,
	}
}

/* AddDeviceDatasourceInstanceGroupDefault describes a response with status code -1, with default header values.

Error
*/
type AddDeviceDatasourceInstanceGroupDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the add device datasource instance group default response
func (o *AddDeviceDatasourceInstanceGroupDefault) Code() int {
	return o._statusCode
}

func (o *AddDeviceDatasourceInstanceGroupDefault) Error() string {
	return fmt.Sprintf("[POST /device/devices/{deviceId}/devicedatasources/{deviceDsId}/groups][%d] addDeviceDatasourceInstanceGroup default  %+v", o._statusCode, o.Payload)
}
func (o *AddDeviceDatasourceInstanceGroupDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddDeviceDatasourceInstanceGroupDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
