// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// NewAddRecipientGroupParams creates a new AddRecipientGroupParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAddRecipientGroupParams() *AddRecipientGroupParams {
	return &AddRecipientGroupParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAddRecipientGroupParamsWithTimeout creates a new AddRecipientGroupParams object
// with the ability to set a timeout on a request.
func NewAddRecipientGroupParamsWithTimeout(timeout time.Duration) *AddRecipientGroupParams {
	return &AddRecipientGroupParams{
		timeout: timeout,
	}
}

// NewAddRecipientGroupParamsWithContext creates a new AddRecipientGroupParams object
// with the ability to set a context for a request.
func NewAddRecipientGroupParamsWithContext(ctx context.Context) *AddRecipientGroupParams {
	return &AddRecipientGroupParams{
		Context: ctx,
	}
}

// NewAddRecipientGroupParamsWithHTTPClient creates a new AddRecipientGroupParams object
// with the ability to set a custom HTTPClient for a request.
func NewAddRecipientGroupParamsWithHTTPClient(client *http.Client) *AddRecipientGroupParams {
	return &AddRecipientGroupParams{
		HTTPClient: client,
	}
}

/* AddRecipientGroupParams contains all the parameters to send to the API endpoint
   for the add recipient group operation.

   Typically these are written to a http.Request.
*/
type AddRecipientGroupParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body *models.RecipientGroup

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the add recipient group params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AddRecipientGroupParams) WithDefaults() *AddRecipientGroupParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the add recipient group params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AddRecipientGroupParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := AddRecipientGroupParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the add recipient group params
func (o *AddRecipientGroupParams) WithTimeout(timeout time.Duration) *AddRecipientGroupParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the add recipient group params
func (o *AddRecipientGroupParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the add recipient group params
func (o *AddRecipientGroupParams) WithContext(ctx context.Context) *AddRecipientGroupParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the add recipient group params
func (o *AddRecipientGroupParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the add recipient group params
func (o *AddRecipientGroupParams) WithHTTPClient(client *http.Client) *AddRecipientGroupParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the add recipient group params
func (o *AddRecipientGroupParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the add recipient group params
func (o *AddRecipientGroupParams) WithUserAgent(userAgent *string) *AddRecipientGroupParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the add recipient group params
func (o *AddRecipientGroupParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the add recipient group params
func (o *AddRecipientGroupParams) WithBody(body *models.RecipientGroup) *AddRecipientGroupParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the add recipient group params
func (o *AddRecipientGroupParams) SetBody(body *models.RecipientGroup) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *AddRecipientGroupParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
