// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// AddReportGroupReader is a Reader for the AddReportGroup structure.
type AddReportGroupReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddReportGroupReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddReportGroupOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddReportGroupTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddReportGroupDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddReportGroupOK creates a AddReportGroupOK with default headers values
func NewAddReportGroupOK() *AddReportGroupOK {
	return &AddReportGroupOK{}
}

/* AddReportGroupOK describes a response with status code 200, with default header values.

successful operation
*/
type AddReportGroupOK struct {
	Payload *models.ReportGroup
}

func (o *AddReportGroupOK) Error() string {
	return fmt.Sprintf("[POST /report/groups][%d] addReportGroupOK  %+v", 200, o.Payload)
}
func (o *AddReportGroupOK) GetPayload() *models.ReportGroup {
	return o.Payload
}

func (o *AddReportGroupOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ReportGroup)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddReportGroupTooManyRequests creates a AddReportGroupTooManyRequests with default headers values
func NewAddReportGroupTooManyRequests() *AddReportGroupTooManyRequests {
	return &AddReportGroupTooManyRequests{}
}

/* AddReportGroupTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddReportGroupTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *AddReportGroupTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /report/groups][%d] addReportGroupTooManyRequests ", 429)
}

func (o *AddReportGroupTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddReportGroupDefault creates a AddReportGroupDefault with default headers values
func NewAddReportGroupDefault(code int) *AddReportGroupDefault {
	return &AddReportGroupDefault{
		_statusCode: code,
	}
}

/* AddReportGroupDefault describes a response with status code -1, with default header values.

Error
*/
type AddReportGroupDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the add report group default response
func (o *AddReportGroupDefault) Code() int {
	return o._statusCode
}

func (o *AddReportGroupDefault) Error() string {
	return fmt.Sprintf("[POST /report/groups][%d] addReportGroup default  %+v", o._statusCode, o.Payload)
}
func (o *AddReportGroupDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddReportGroupDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
