// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// NewAddSDTParams creates a new AddSDTParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAddSDTParams() *AddSDTParams {
	return &AddSDTParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAddSDTParamsWithTimeout creates a new AddSDTParams object
// with the ability to set a timeout on a request.
func NewAddSDTParamsWithTimeout(timeout time.Duration) *AddSDTParams {
	return &AddSDTParams{
		timeout: timeout,
	}
}

// NewAddSDTParamsWithContext creates a new AddSDTParams object
// with the ability to set a context for a request.
func NewAddSDTParamsWithContext(ctx context.Context) *AddSDTParams {
	return &AddSDTParams{
		Context: ctx,
	}
}

// NewAddSDTParamsWithHTTPClient creates a new AddSDTParams object
// with the ability to set a custom HTTPClient for a request.
func NewAddSDTParamsWithHTTPClient(client *http.Client) *AddSDTParams {
	return &AddSDTParams{
		HTTPClient: client,
	}
}

/* AddSDTParams contains all the parameters to send to the API endpoint
   for the add SDT operation.

   Typically these are written to a http.Request.
*/
type AddSDTParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body models.SDT

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the add SDT params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AddSDTParams) WithDefaults() *AddSDTParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the add SDT params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AddSDTParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := AddSDTParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the add SDT params
func (o *AddSDTParams) WithTimeout(timeout time.Duration) *AddSDTParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the add SDT params
func (o *AddSDTParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the add SDT params
func (o *AddSDTParams) WithContext(ctx context.Context) *AddSDTParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the add SDT params
func (o *AddSDTParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the add SDT params
func (o *AddSDTParams) WithHTTPClient(client *http.Client) *AddSDTParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the add SDT params
func (o *AddSDTParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the add SDT params
func (o *AddSDTParams) WithUserAgent(userAgent *string) *AddSDTParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the add SDT params
func (o *AddSDTParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the add SDT params
func (o *AddSDTParams) WithBody(body models.SDT) *AddSDTParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the add SDT params
func (o *AddSDTParams) SetBody(body models.SDT) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *AddSDTParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
