// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// DeleteDashboardGroupByIDReader is a Reader for the DeleteDashboardGroupByID structure.
type DeleteDashboardGroupByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteDashboardGroupByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteDashboardGroupByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewDeleteDashboardGroupByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewDeleteDashboardGroupByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewDeleteDashboardGroupByIDOK creates a DeleteDashboardGroupByIDOK with default headers values
func NewDeleteDashboardGroupByIDOK() *DeleteDashboardGroupByIDOK {
	return &DeleteDashboardGroupByIDOK{}
}

/* DeleteDashboardGroupByIDOK describes a response with status code 200, with default header values.

OK
*/
type DeleteDashboardGroupByIDOK struct {
	Payload interface{}
}

func (o *DeleteDashboardGroupByIDOK) Error() string {
	return fmt.Sprintf("[DELETE /dashboard/groups/{id}][%d] deleteDashboardGroupByIdOK  %+v", 200, o.Payload)
}
func (o *DeleteDashboardGroupByIDOK) GetPayload() interface{} {
	return o.Payload
}

func (o *DeleteDashboardGroupByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteDashboardGroupByIDTooManyRequests creates a DeleteDashboardGroupByIDTooManyRequests with default headers values
func NewDeleteDashboardGroupByIDTooManyRequests() *DeleteDashboardGroupByIDTooManyRequests {
	return &DeleteDashboardGroupByIDTooManyRequests{}
}

/* DeleteDashboardGroupByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type DeleteDashboardGroupByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *DeleteDashboardGroupByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[DELETE /dashboard/groups/{id}][%d] deleteDashboardGroupByIdTooManyRequests ", 429)
}

func (o *DeleteDashboardGroupByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewDeleteDashboardGroupByIDDefault creates a DeleteDashboardGroupByIDDefault with default headers values
func NewDeleteDashboardGroupByIDDefault(code int) *DeleteDashboardGroupByIDDefault {
	return &DeleteDashboardGroupByIDDefault{
		_statusCode: code,
	}
}

/* DeleteDashboardGroupByIDDefault describes a response with status code -1, with default header values.

Error
*/
type DeleteDashboardGroupByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the delete dashboard group by Id default response
func (o *DeleteDashboardGroupByIDDefault) Code() int {
	return o._statusCode
}

func (o *DeleteDashboardGroupByIDDefault) Error() string {
	return fmt.Sprintf("[DELETE /dashboard/groups/{id}][%d] deleteDashboardGroupById default  %+v", o._statusCode, o.Payload)
}
func (o *DeleteDashboardGroupByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *DeleteDashboardGroupByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
