// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// FetchDeviceInstancesDataReader is a Reader for the FetchDeviceInstancesData structure.
type FetchDeviceInstancesDataReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *FetchDeviceInstancesDataReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewFetchDeviceInstancesDataOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewFetchDeviceInstancesDataTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewFetchDeviceInstancesDataDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewFetchDeviceInstancesDataOK creates a FetchDeviceInstancesDataOK with default headers values
func NewFetchDeviceInstancesDataOK() *FetchDeviceInstancesDataOK {
	return &FetchDeviceInstancesDataOK{}
}

/* FetchDeviceInstancesDataOK describes a response with status code 200, with default header values.

successful operation
*/
type FetchDeviceInstancesDataOK struct {
	Payload *models.DeviceInstanceDataPaginationResponse
}

func (o *FetchDeviceInstancesDataOK) Error() string {
	return fmt.Sprintf("[POST /device/instances/datafetch][%d] fetchDeviceInstancesDataOK  %+v", 200, o.Payload)
}
func (o *FetchDeviceInstancesDataOK) GetPayload() *models.DeviceInstanceDataPaginationResponse {
	return o.Payload
}

func (o *FetchDeviceInstancesDataOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DeviceInstanceDataPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewFetchDeviceInstancesDataTooManyRequests creates a FetchDeviceInstancesDataTooManyRequests with default headers values
func NewFetchDeviceInstancesDataTooManyRequests() *FetchDeviceInstancesDataTooManyRequests {
	return &FetchDeviceInstancesDataTooManyRequests{}
}

/* FetchDeviceInstancesDataTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type FetchDeviceInstancesDataTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *FetchDeviceInstancesDataTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /device/instances/datafetch][%d] fetchDeviceInstancesDataTooManyRequests ", 429)
}

func (o *FetchDeviceInstancesDataTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewFetchDeviceInstancesDataDefault creates a FetchDeviceInstancesDataDefault with default headers values
func NewFetchDeviceInstancesDataDefault(code int) *FetchDeviceInstancesDataDefault {
	return &FetchDeviceInstancesDataDefault{
		_statusCode: code,
	}
}

/* FetchDeviceInstancesDataDefault describes a response with status code -1, with default header values.

Error
*/
type FetchDeviceInstancesDataDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the fetch device instances data default response
func (o *FetchDeviceInstancesDataDefault) Code() int {
	return o._statusCode
}

func (o *FetchDeviceInstancesDataDefault) Error() string {
	return fmt.Sprintf("[POST /device/instances/datafetch][%d] fetchDeviceInstancesData default  %+v", o._statusCode, o.Payload)
}
func (o *FetchDeviceInstancesDataDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *FetchDeviceInstancesDataDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
