// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetAlertListByDeviceGroupIDReader is a Reader for the GetAlertListByDeviceGroupID structure.
type GetAlertListByDeviceGroupIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAlertListByDeviceGroupIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAlertListByDeviceGroupIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetAlertListByDeviceGroupIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetAlertListByDeviceGroupIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetAlertListByDeviceGroupIDOK creates a GetAlertListByDeviceGroupIDOK with default headers values
func NewGetAlertListByDeviceGroupIDOK() *GetAlertListByDeviceGroupIDOK {
	return &GetAlertListByDeviceGroupIDOK{}
}

/* GetAlertListByDeviceGroupIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetAlertListByDeviceGroupIDOK struct {
	Payload *models.AlertPaginationResponse
}

func (o *GetAlertListByDeviceGroupIDOK) Error() string {
	return fmt.Sprintf("[GET /device/groups/{id}/alerts][%d] getAlertListByDeviceGroupIdOK  %+v", 200, o.Payload)
}
func (o *GetAlertListByDeviceGroupIDOK) GetPayload() *models.AlertPaginationResponse {
	return o.Payload
}

func (o *GetAlertListByDeviceGroupIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.AlertPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAlertListByDeviceGroupIDTooManyRequests creates a GetAlertListByDeviceGroupIDTooManyRequests with default headers values
func NewGetAlertListByDeviceGroupIDTooManyRequests() *GetAlertListByDeviceGroupIDTooManyRequests {
	return &GetAlertListByDeviceGroupIDTooManyRequests{}
}

/* GetAlertListByDeviceGroupIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetAlertListByDeviceGroupIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetAlertListByDeviceGroupIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/groups/{id}/alerts][%d] getAlertListByDeviceGroupIdTooManyRequests ", 429)
}

func (o *GetAlertListByDeviceGroupIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetAlertListByDeviceGroupIDDefault creates a GetAlertListByDeviceGroupIDDefault with default headers values
func NewGetAlertListByDeviceGroupIDDefault(code int) *GetAlertListByDeviceGroupIDDefault {
	return &GetAlertListByDeviceGroupIDDefault{
		_statusCode: code,
	}
}

/* GetAlertListByDeviceGroupIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetAlertListByDeviceGroupIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get alert list by device group Id default response
func (o *GetAlertListByDeviceGroupIDDefault) Code() int {
	return o._statusCode
}

func (o *GetAlertListByDeviceGroupIDDefault) Error() string {
	return fmt.Sprintf("[GET /device/groups/{id}/alerts][%d] getAlertListByDeviceGroupId default  %+v", o._statusCode, o.Payload)
}
func (o *GetAlertListByDeviceGroupIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetAlertListByDeviceGroupIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
