// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetAllSDTListByDeviceIDReader is a Reader for the GetAllSDTListByDeviceID structure.
type GetAllSDTListByDeviceIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAllSDTListByDeviceIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAllSDTListByDeviceIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetAllSDTListByDeviceIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetAllSDTListByDeviceIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetAllSDTListByDeviceIDOK creates a GetAllSDTListByDeviceIDOK with default headers values
func NewGetAllSDTListByDeviceIDOK() *GetAllSDTListByDeviceIDOK {
	return &GetAllSDTListByDeviceIDOK{}
}

/* GetAllSDTListByDeviceIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetAllSDTListByDeviceIDOK struct {
	Payload *models.SDTPaginationResponse
}

func (o *GetAllSDTListByDeviceIDOK) Error() string {
	return fmt.Sprintf("[GET /device/devices/{id}/sdts][%d] getAllSdtListByDeviceIdOK  %+v", 200, o.Payload)
}
func (o *GetAllSDTListByDeviceIDOK) GetPayload() *models.SDTPaginationResponse {
	return o.Payload
}

func (o *GetAllSDTListByDeviceIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.SDTPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAllSDTListByDeviceIDTooManyRequests creates a GetAllSDTListByDeviceIDTooManyRequests with default headers values
func NewGetAllSDTListByDeviceIDTooManyRequests() *GetAllSDTListByDeviceIDTooManyRequests {
	return &GetAllSDTListByDeviceIDTooManyRequests{}
}

/* GetAllSDTListByDeviceIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetAllSDTListByDeviceIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetAllSDTListByDeviceIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/devices/{id}/sdts][%d] getAllSdtListByDeviceIdTooManyRequests ", 429)
}

func (o *GetAllSDTListByDeviceIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetAllSDTListByDeviceIDDefault creates a GetAllSDTListByDeviceIDDefault with default headers values
func NewGetAllSDTListByDeviceIDDefault(code int) *GetAllSDTListByDeviceIDDefault {
	return &GetAllSDTListByDeviceIDDefault{
		_statusCode: code,
	}
}

/* GetAllSDTListByDeviceIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetAllSDTListByDeviceIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get all SDT list by device Id default response
func (o *GetAllSDTListByDeviceIDDefault) Code() int {
	return o._statusCode
}

func (o *GetAllSDTListByDeviceIDDefault) Error() string {
	return fmt.Sprintf("[GET /device/devices/{id}/sdts][%d] getAllSDTListByDeviceId default  %+v", o._statusCode, o.Payload)
}
func (o *GetAllSDTListByDeviceIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetAllSDTListByDeviceIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
