// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetAPITokenListReader is a Reader for the GetAPITokenList structure.
type GetAPITokenListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAPITokenListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAPITokenListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetAPITokenListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetAPITokenListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetAPITokenListOK creates a GetAPITokenListOK with default headers values
func NewGetAPITokenListOK() *GetAPITokenListOK {
	return &GetAPITokenListOK{}
}

/* GetAPITokenListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetAPITokenListOK struct {
	Payload *models.APITokenPaginationResponse
}

func (o *GetAPITokenListOK) Error() string {
	return fmt.Sprintf("[GET /setting/admins/apitokens][%d] getApiTokenListOK  %+v", 200, o.Payload)
}
func (o *GetAPITokenListOK) GetPayload() *models.APITokenPaginationResponse {
	return o.Payload
}

func (o *GetAPITokenListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.APITokenPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAPITokenListTooManyRequests creates a GetAPITokenListTooManyRequests with default headers values
func NewGetAPITokenListTooManyRequests() *GetAPITokenListTooManyRequests {
	return &GetAPITokenListTooManyRequests{}
}

/* GetAPITokenListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetAPITokenListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetAPITokenListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/admins/apitokens][%d] getApiTokenListTooManyRequests ", 429)
}

func (o *GetAPITokenListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetAPITokenListDefault creates a GetAPITokenListDefault with default headers values
func NewGetAPITokenListDefault(code int) *GetAPITokenListDefault {
	return &GetAPITokenListDefault{
		_statusCode: code,
	}
}

/* GetAPITokenListDefault describes a response with status code -1, with default header values.

Error
*/
type GetAPITokenListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get Api token list default response
func (o *GetAPITokenListDefault) Code() int {
	return o._statusCode
}

func (o *GetAPITokenListDefault) Error() string {
	return fmt.Sprintf("[GET /setting/admins/apitokens][%d] getApiTokenList default  %+v", o._statusCode, o.Payload)
}
func (o *GetAPITokenListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetAPITokenListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
