// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetAppliesToFunctionByIDReader is a Reader for the GetAppliesToFunctionByID structure.
type GetAppliesToFunctionByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAppliesToFunctionByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAppliesToFunctionByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetAppliesToFunctionByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetAppliesToFunctionByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetAppliesToFunctionByIDOK creates a GetAppliesToFunctionByIDOK with default headers values
func NewGetAppliesToFunctionByIDOK() *GetAppliesToFunctionByIDOK {
	return &GetAppliesToFunctionByIDOK{}
}

/* GetAppliesToFunctionByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetAppliesToFunctionByIDOK struct {
	Payload *models.AppliesToFunction
}

func (o *GetAppliesToFunctionByIDOK) Error() string {
	return fmt.Sprintf("[GET /setting/functions/{id}][%d] getAppliesToFunctionByIdOK  %+v", 200, o.Payload)
}
func (o *GetAppliesToFunctionByIDOK) GetPayload() *models.AppliesToFunction {
	return o.Payload
}

func (o *GetAppliesToFunctionByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.AppliesToFunction)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAppliesToFunctionByIDTooManyRequests creates a GetAppliesToFunctionByIDTooManyRequests with default headers values
func NewGetAppliesToFunctionByIDTooManyRequests() *GetAppliesToFunctionByIDTooManyRequests {
	return &GetAppliesToFunctionByIDTooManyRequests{}
}

/* GetAppliesToFunctionByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetAppliesToFunctionByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetAppliesToFunctionByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/functions/{id}][%d] getAppliesToFunctionByIdTooManyRequests ", 429)
}

func (o *GetAppliesToFunctionByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetAppliesToFunctionByIDDefault creates a GetAppliesToFunctionByIDDefault with default headers values
func NewGetAppliesToFunctionByIDDefault(code int) *GetAppliesToFunctionByIDDefault {
	return &GetAppliesToFunctionByIDDefault{
		_statusCode: code,
	}
}

/* GetAppliesToFunctionByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetAppliesToFunctionByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get applies to function by Id default response
func (o *GetAppliesToFunctionByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetAppliesToFunctionByIDDefault) Error() string {
	return fmt.Sprintf("[GET /setting/functions/{id}][%d] getAppliesToFunctionById default  %+v", o._statusCode, o.Payload)
}
func (o *GetAppliesToFunctionByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetAppliesToFunctionByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
