// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetCollectorVersionListReader is a Reader for the GetCollectorVersionList structure.
type GetCollectorVersionListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCollectorVersionListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetCollectorVersionListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetCollectorVersionListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetCollectorVersionListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetCollectorVersionListOK creates a GetCollectorVersionListOK with default headers values
func NewGetCollectorVersionListOK() *GetCollectorVersionListOK {
	return &GetCollectorVersionListOK{}
}

/* GetCollectorVersionListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetCollectorVersionListOK struct {
	Payload *models.CollectorVersionPaginationResponse
}

func (o *GetCollectorVersionListOK) Error() string {
	return fmt.Sprintf("[GET /setting/collector/collectors/versions][%d] getCollectorVersionListOK  %+v", 200, o.Payload)
}
func (o *GetCollectorVersionListOK) GetPayload() *models.CollectorVersionPaginationResponse {
	return o.Payload
}

func (o *GetCollectorVersionListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.CollectorVersionPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCollectorVersionListTooManyRequests creates a GetCollectorVersionListTooManyRequests with default headers values
func NewGetCollectorVersionListTooManyRequests() *GetCollectorVersionListTooManyRequests {
	return &GetCollectorVersionListTooManyRequests{}
}

/* GetCollectorVersionListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetCollectorVersionListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetCollectorVersionListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/collector/collectors/versions][%d] getCollectorVersionListTooManyRequests ", 429)
}

func (o *GetCollectorVersionListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetCollectorVersionListDefault creates a GetCollectorVersionListDefault with default headers values
func NewGetCollectorVersionListDefault(code int) *GetCollectorVersionListDefault {
	return &GetCollectorVersionListDefault{
		_statusCode: code,
	}
}

/* GetCollectorVersionListDefault describes a response with status code -1, with default header values.

Error
*/
type GetCollectorVersionListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get collector version list default response
func (o *GetCollectorVersionListDefault) Code() int {
	return o._statusCode
}

func (o *GetCollectorVersionListDefault) Error() string {
	return fmt.Sprintf("[GET /setting/collector/collectors/versions][%d] getCollectorVersionList default  %+v", o._statusCode, o.Payload)
}
func (o *GetCollectorVersionListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetCollectorVersionListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
