// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetDeltaDevicesReader is a Reader for the GetDeltaDevices structure.
type GetDeltaDevicesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDeltaDevicesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDeltaDevicesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDeltaDevicesTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDeltaDevicesDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDeltaDevicesOK creates a GetDeltaDevicesOK with default headers values
func NewGetDeltaDevicesOK() *GetDeltaDevicesOK {
	return &GetDeltaDevicesOK{}
}

/* GetDeltaDevicesOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDeltaDevicesOK struct {
	Payload *models.DeviceDeltaPaginationResponse
}

func (o *GetDeltaDevicesOK) Error() string {
	return fmt.Sprintf("[GET /device/devices/delta/{deltaId}][%d] getDeltaDevicesOK  %+v", 200, o.Payload)
}
func (o *GetDeltaDevicesOK) GetPayload() *models.DeviceDeltaPaginationResponse {
	return o.Payload
}

func (o *GetDeltaDevicesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DeviceDeltaPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDeltaDevicesTooManyRequests creates a GetDeltaDevicesTooManyRequests with default headers values
func NewGetDeltaDevicesTooManyRequests() *GetDeltaDevicesTooManyRequests {
	return &GetDeltaDevicesTooManyRequests{}
}

/* GetDeltaDevicesTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDeltaDevicesTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetDeltaDevicesTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/devices/delta/{deltaId}][%d] getDeltaDevicesTooManyRequests ", 429)
}

func (o *GetDeltaDevicesTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDeltaDevicesDefault creates a GetDeltaDevicesDefault with default headers values
func NewGetDeltaDevicesDefault(code int) *GetDeltaDevicesDefault {
	return &GetDeltaDevicesDefault{
		_statusCode: code,
	}
}

/* GetDeltaDevicesDefault describes a response with status code -1, with default header values.

Error
*/
type GetDeltaDevicesDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get delta devices default response
func (o *GetDeltaDevicesDefault) Code() int {
	return o._statusCode
}

func (o *GetDeltaDevicesDefault) Error() string {
	return fmt.Sprintf("[GET /device/devices/delta/{deltaId}][%d] getDeltaDevices default  %+v", o._statusCode, o.Payload)
}
func (o *GetDeltaDevicesDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDeltaDevicesDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
