// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetDeviceConfigSourceConfigListReader is a Reader for the GetDeviceConfigSourceConfigList structure.
type GetDeviceConfigSourceConfigListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDeviceConfigSourceConfigListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDeviceConfigSourceConfigListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDeviceConfigSourceConfigListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDeviceConfigSourceConfigListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDeviceConfigSourceConfigListOK creates a GetDeviceConfigSourceConfigListOK with default headers values
func NewGetDeviceConfigSourceConfigListOK() *GetDeviceConfigSourceConfigListOK {
	return &GetDeviceConfigSourceConfigListOK{}
}

/* GetDeviceConfigSourceConfigListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDeviceConfigSourceConfigListOK struct {
	Payload *models.DeviceDatasourceInstanceConfigPaginationResponse
}

func (o *GetDeviceConfigSourceConfigListOK) Error() string {
	return fmt.Sprintf("[GET /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{instanceId}/config][%d] getDeviceConfigSourceConfigListOK  %+v", 200, o.Payload)
}
func (o *GetDeviceConfigSourceConfigListOK) GetPayload() *models.DeviceDatasourceInstanceConfigPaginationResponse {
	return o.Payload
}

func (o *GetDeviceConfigSourceConfigListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DeviceDatasourceInstanceConfigPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDeviceConfigSourceConfigListTooManyRequests creates a GetDeviceConfigSourceConfigListTooManyRequests with default headers values
func NewGetDeviceConfigSourceConfigListTooManyRequests() *GetDeviceConfigSourceConfigListTooManyRequests {
	return &GetDeviceConfigSourceConfigListTooManyRequests{}
}

/* GetDeviceConfigSourceConfigListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDeviceConfigSourceConfigListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetDeviceConfigSourceConfigListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{instanceId}/config][%d] getDeviceConfigSourceConfigListTooManyRequests ", 429)
}

func (o *GetDeviceConfigSourceConfigListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDeviceConfigSourceConfigListDefault creates a GetDeviceConfigSourceConfigListDefault with default headers values
func NewGetDeviceConfigSourceConfigListDefault(code int) *GetDeviceConfigSourceConfigListDefault {
	return &GetDeviceConfigSourceConfigListDefault{
		_statusCode: code,
	}
}

/* GetDeviceConfigSourceConfigListDefault describes a response with status code -1, with default header values.

Error
*/
type GetDeviceConfigSourceConfigListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get device config source config list default response
func (o *GetDeviceConfigSourceConfigListDefault) Code() int {
	return o._statusCode
}

func (o *GetDeviceConfigSourceConfigListDefault) Error() string {
	return fmt.Sprintf("[GET /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{instanceId}/config][%d] getDeviceConfigSourceConfigList default  %+v", o._statusCode, o.Payload)
}
func (o *GetDeviceConfigSourceConfigListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDeviceConfigSourceConfigListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
