// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetDeviceGroupByIDReader is a Reader for the GetDeviceGroupByID structure.
type GetDeviceGroupByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDeviceGroupByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDeviceGroupByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDeviceGroupByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDeviceGroupByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDeviceGroupByIDOK creates a GetDeviceGroupByIDOK with default headers values
func NewGetDeviceGroupByIDOK() *GetDeviceGroupByIDOK {
	return &GetDeviceGroupByIDOK{}
}

/* GetDeviceGroupByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDeviceGroupByIDOK struct {
	Payload *models.DeviceGroup
}

func (o *GetDeviceGroupByIDOK) Error() string {
	return fmt.Sprintf("[GET /device/groups/{id}][%d] getDeviceGroupByIdOK  %+v", 200, o.Payload)
}
func (o *GetDeviceGroupByIDOK) GetPayload() *models.DeviceGroup {
	return o.Payload
}

func (o *GetDeviceGroupByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DeviceGroup)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDeviceGroupByIDTooManyRequests creates a GetDeviceGroupByIDTooManyRequests with default headers values
func NewGetDeviceGroupByIDTooManyRequests() *GetDeviceGroupByIDTooManyRequests {
	return &GetDeviceGroupByIDTooManyRequests{}
}

/* GetDeviceGroupByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDeviceGroupByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetDeviceGroupByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/groups/{id}][%d] getDeviceGroupByIdTooManyRequests ", 429)
}

func (o *GetDeviceGroupByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDeviceGroupByIDDefault creates a GetDeviceGroupByIDDefault with default headers values
func NewGetDeviceGroupByIDDefault(code int) *GetDeviceGroupByIDDefault {
	return &GetDeviceGroupByIDDefault{
		_statusCode: code,
	}
}

/* GetDeviceGroupByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetDeviceGroupByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get device group by Id default response
func (o *GetDeviceGroupByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetDeviceGroupByIDDefault) Error() string {
	return fmt.Sprintf("[GET /device/groups/{id}][%d] getDeviceGroupById default  %+v", o._statusCode, o.Payload)
}
func (o *GetDeviceGroupByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDeviceGroupByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
