// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetDeviceGroupSDTListReader is a Reader for the GetDeviceGroupSDTList structure.
type GetDeviceGroupSDTListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDeviceGroupSDTListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDeviceGroupSDTListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDeviceGroupSDTListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDeviceGroupSDTListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDeviceGroupSDTListOK creates a GetDeviceGroupSDTListOK with default headers values
func NewGetDeviceGroupSDTListOK() *GetDeviceGroupSDTListOK {
	return &GetDeviceGroupSDTListOK{}
}

/* GetDeviceGroupSDTListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDeviceGroupSDTListOK struct {
	Payload *models.SDTPaginationResponse
}

func (o *GetDeviceGroupSDTListOK) Error() string {
	return fmt.Sprintf("[GET /device/groups/{id}/sdts][%d] getDeviceGroupSdtListOK  %+v", 200, o.Payload)
}
func (o *GetDeviceGroupSDTListOK) GetPayload() *models.SDTPaginationResponse {
	return o.Payload
}

func (o *GetDeviceGroupSDTListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.SDTPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDeviceGroupSDTListTooManyRequests creates a GetDeviceGroupSDTListTooManyRequests with default headers values
func NewGetDeviceGroupSDTListTooManyRequests() *GetDeviceGroupSDTListTooManyRequests {
	return &GetDeviceGroupSDTListTooManyRequests{}
}

/* GetDeviceGroupSDTListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDeviceGroupSDTListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetDeviceGroupSDTListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/groups/{id}/sdts][%d] getDeviceGroupSdtListTooManyRequests ", 429)
}

func (o *GetDeviceGroupSDTListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDeviceGroupSDTListDefault creates a GetDeviceGroupSDTListDefault with default headers values
func NewGetDeviceGroupSDTListDefault(code int) *GetDeviceGroupSDTListDefault {
	return &GetDeviceGroupSDTListDefault{
		_statusCode: code,
	}
}

/* GetDeviceGroupSDTListDefault describes a response with status code -1, with default header values.

Error
*/
type GetDeviceGroupSDTListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get device group SDT list default response
func (o *GetDeviceGroupSDTListDefault) Code() int {
	return o._statusCode
}

func (o *GetDeviceGroupSDTListDefault) Error() string {
	return fmt.Sprintf("[GET /device/groups/{id}/sdts][%d] getDeviceGroupSDTList default  %+v", o._statusCode, o.Payload)
}
func (o *GetDeviceGroupSDTListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDeviceGroupSDTListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
