// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetEscalationChainByIDReader is a Reader for the GetEscalationChainByID structure.
type GetEscalationChainByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetEscalationChainByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetEscalationChainByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetEscalationChainByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetEscalationChainByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetEscalationChainByIDOK creates a GetEscalationChainByIDOK with default headers values
func NewGetEscalationChainByIDOK() *GetEscalationChainByIDOK {
	return &GetEscalationChainByIDOK{}
}

/* GetEscalationChainByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetEscalationChainByIDOK struct {
	Payload *models.EscalatingChain
}

func (o *GetEscalationChainByIDOK) Error() string {
	return fmt.Sprintf("[GET /setting/alert/chains/{id}][%d] getEscalationChainByIdOK  %+v", 200, o.Payload)
}
func (o *GetEscalationChainByIDOK) GetPayload() *models.EscalatingChain {
	return o.Payload
}

func (o *GetEscalationChainByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.EscalatingChain)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetEscalationChainByIDTooManyRequests creates a GetEscalationChainByIDTooManyRequests with default headers values
func NewGetEscalationChainByIDTooManyRequests() *GetEscalationChainByIDTooManyRequests {
	return &GetEscalationChainByIDTooManyRequests{}
}

/* GetEscalationChainByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetEscalationChainByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetEscalationChainByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/alert/chains/{id}][%d] getEscalationChainByIdTooManyRequests ", 429)
}

func (o *GetEscalationChainByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetEscalationChainByIDDefault creates a GetEscalationChainByIDDefault with default headers values
func NewGetEscalationChainByIDDefault(code int) *GetEscalationChainByIDDefault {
	return &GetEscalationChainByIDDefault{
		_statusCode: code,
	}
}

/* GetEscalationChainByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetEscalationChainByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get escalation chain by Id default response
func (o *GetEscalationChainByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetEscalationChainByIDDefault) Error() string {
	return fmt.Sprintf("[GET /setting/alert/chains/{id}][%d] getEscalationChainById default  %+v", o._statusCode, o.Payload)
}
func (o *GetEscalationChainByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetEscalationChainByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
