// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetExternalAPIStatsReader is a Reader for the GetExternalAPIStats structure.
type GetExternalAPIStatsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetExternalAPIStatsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetExternalAPIStatsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetExternalAPIStatsTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetExternalAPIStatsDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetExternalAPIStatsOK creates a GetExternalAPIStatsOK with default headers values
func NewGetExternalAPIStatsOK() *GetExternalAPIStatsOK {
	return &GetExternalAPIStatsOK{}
}

/* GetExternalAPIStatsOK describes a response with status code 200, with default header values.

successful operation
*/
type GetExternalAPIStatsOK struct {
	Payload *models.APIPerfMetrics
}

func (o *GetExternalAPIStatsOK) Error() string {
	return fmt.Sprintf("[GET /apiStats/externalApis][%d] getExternalApiStatsOK  %+v", 200, o.Payload)
}
func (o *GetExternalAPIStatsOK) GetPayload() *models.APIPerfMetrics {
	return o.Payload
}

func (o *GetExternalAPIStatsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.APIPerfMetrics)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetExternalAPIStatsTooManyRequests creates a GetExternalAPIStatsTooManyRequests with default headers values
func NewGetExternalAPIStatsTooManyRequests() *GetExternalAPIStatsTooManyRequests {
	return &GetExternalAPIStatsTooManyRequests{}
}

/* GetExternalAPIStatsTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetExternalAPIStatsTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetExternalAPIStatsTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /apiStats/externalApis][%d] getExternalApiStatsTooManyRequests ", 429)
}

func (o *GetExternalAPIStatsTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetExternalAPIStatsDefault creates a GetExternalAPIStatsDefault with default headers values
func NewGetExternalAPIStatsDefault(code int) *GetExternalAPIStatsDefault {
	return &GetExternalAPIStatsDefault{
		_statusCode: code,
	}
}

/* GetExternalAPIStatsDefault describes a response with status code -1, with default header values.

Error
*/
type GetExternalAPIStatsDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get external Api stats default response
func (o *GetExternalAPIStatsDefault) Code() int {
	return o._statusCode
}

func (o *GetExternalAPIStatsDefault) Error() string {
	return fmt.Sprintf("[GET /apiStats/externalApis][%d] getExternalApiStats default  %+v", o._statusCode, o.Payload)
}
func (o *GetExternalAPIStatsDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetExternalAPIStatsDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
