// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetReportGroupListReader is a Reader for the GetReportGroupList structure.
type GetReportGroupListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetReportGroupListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetReportGroupListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetReportGroupListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetReportGroupListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetReportGroupListOK creates a GetReportGroupListOK with default headers values
func NewGetReportGroupListOK() *GetReportGroupListOK {
	return &GetReportGroupListOK{}
}

/* GetReportGroupListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetReportGroupListOK struct {
	Payload *models.ReportGroupPaginationResponse
}

func (o *GetReportGroupListOK) Error() string {
	return fmt.Sprintf("[GET /report/groups][%d] getReportGroupListOK  %+v", 200, o.Payload)
}
func (o *GetReportGroupListOK) GetPayload() *models.ReportGroupPaginationResponse {
	return o.Payload
}

func (o *GetReportGroupListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ReportGroupPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetReportGroupListTooManyRequests creates a GetReportGroupListTooManyRequests with default headers values
func NewGetReportGroupListTooManyRequests() *GetReportGroupListTooManyRequests {
	return &GetReportGroupListTooManyRequests{}
}

/* GetReportGroupListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetReportGroupListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetReportGroupListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /report/groups][%d] getReportGroupListTooManyRequests ", 429)
}

func (o *GetReportGroupListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetReportGroupListDefault creates a GetReportGroupListDefault with default headers values
func NewGetReportGroupListDefault(code int) *GetReportGroupListDefault {
	return &GetReportGroupListDefault{
		_statusCode: code,
	}
}

/* GetReportGroupListDefault describes a response with status code -1, with default header values.

Error
*/
type GetReportGroupListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get report group list default response
func (o *GetReportGroupListDefault) Code() int {
	return o._statusCode
}

func (o *GetReportGroupListDefault) Error() string {
	return fmt.Sprintf("[GET /report/groups][%d] getReportGroupList default  %+v", o._statusCode, o.Payload)
}
func (o *GetReportGroupListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetReportGroupListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
