// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetReportListReader is a Reader for the GetReportList structure.
type GetReportListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetReportListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetReportListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetReportListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetReportListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetReportListOK creates a GetReportListOK with default headers values
func NewGetReportListOK() *GetReportListOK {
	return &GetReportListOK{}
}

/* GetReportListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetReportListOK struct {
	Payload *models.ReportPaginationResponse
}

func (o *GetReportListOK) Error() string {
	return fmt.Sprintf("[GET /report/reports][%d] getReportListOK  %+v", 200, o.Payload)
}
func (o *GetReportListOK) GetPayload() *models.ReportPaginationResponse {
	return o.Payload
}

func (o *GetReportListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ReportPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetReportListTooManyRequests creates a GetReportListTooManyRequests with default headers values
func NewGetReportListTooManyRequests() *GetReportListTooManyRequests {
	return &GetReportListTooManyRequests{}
}

/* GetReportListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetReportListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetReportListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /report/reports][%d] getReportListTooManyRequests ", 429)
}

func (o *GetReportListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetReportListDefault creates a GetReportListDefault with default headers values
func NewGetReportListDefault(code int) *GetReportListDefault {
	return &GetReportListDefault{
		_statusCode: code,
	}
}

/* GetReportListDefault describes a response with status code -1, with default header values.

Error
*/
type GetReportListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get report list default response
func (o *GetReportListDefault) Code() int {
	return o._statusCode
}

func (o *GetReportListDefault) Error() string {
	return fmt.Sprintf("[GET /report/reports][%d] getReportList default  %+v", o._statusCode, o.Payload)
}
func (o *GetReportListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetReportListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
