// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetRoleByIDReader is a Reader for the GetRoleByID structure.
type GetRoleByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetRoleByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetRoleByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetRoleByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetRoleByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetRoleByIDOK creates a GetRoleByIDOK with default headers values
func NewGetRoleByIDOK() *GetRoleByIDOK {
	return &GetRoleByIDOK{}
}

/* GetRoleByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetRoleByIDOK struct {
	Payload *models.Role
}

func (o *GetRoleByIDOK) Error() string {
	return fmt.Sprintf("[GET /setting/roles/{id}][%d] getRoleByIdOK  %+v", 200, o.Payload)
}
func (o *GetRoleByIDOK) GetPayload() *models.Role {
	return o.Payload
}

func (o *GetRoleByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Role)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRoleByIDTooManyRequests creates a GetRoleByIDTooManyRequests with default headers values
func NewGetRoleByIDTooManyRequests() *GetRoleByIDTooManyRequests {
	return &GetRoleByIDTooManyRequests{}
}

/* GetRoleByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetRoleByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetRoleByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/roles/{id}][%d] getRoleByIdTooManyRequests ", 429)
}

func (o *GetRoleByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetRoleByIDDefault creates a GetRoleByIDDefault with default headers values
func NewGetRoleByIDDefault(code int) *GetRoleByIDDefault {
	return &GetRoleByIDDefault{
		_statusCode: code,
	}
}

/* GetRoleByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetRoleByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get role by Id default response
func (o *GetRoleByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetRoleByIDDefault) Error() string {
	return fmt.Sprintf("[GET /setting/roles/{id}][%d] getRoleById default  %+v", o._statusCode, o.Payload)
}
func (o *GetRoleByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetRoleByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
