// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetSDTByIDReader is a Reader for the GetSDTByID structure.
type GetSDTByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetSDTByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetSDTByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetSDTByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetSDTByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetSDTByIDOK creates a GetSDTByIDOK with default headers values
func NewGetSDTByIDOK() *GetSDTByIDOK {
	return &GetSDTByIDOK{}
}

/* GetSDTByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetSDTByIDOK struct {
	Payload models.SDT
}

func (o *GetSDTByIDOK) Error() string {
	return fmt.Sprintf("[GET /sdt/sdts/{id}][%d] getSdtByIdOK  %+v", 200, o.Payload)
}
func (o *GetSDTByIDOK) GetPayload() models.SDT {
	return o.Payload
}

func (o *GetSDTByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload as interface type
	payload, err := models.UnmarshalSDT(response.Body(), consumer)
	if err != nil {
		return err
	}
	o.Payload = payload

	return nil
}

// NewGetSDTByIDTooManyRequests creates a GetSDTByIDTooManyRequests with default headers values
func NewGetSDTByIDTooManyRequests() *GetSDTByIDTooManyRequests {
	return &GetSDTByIDTooManyRequests{}
}

/* GetSDTByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetSDTByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetSDTByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /sdt/sdts/{id}][%d] getSdtByIdTooManyRequests ", 429)
}

func (o *GetSDTByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetSDTByIDDefault creates a GetSDTByIDDefault with default headers values
func NewGetSDTByIDDefault(code int) *GetSDTByIDDefault {
	return &GetSDTByIDDefault{
		_statusCode: code,
	}
}

/* GetSDTByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetSDTByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get SDT by Id default response
func (o *GetSDTByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetSDTByIDDefault) Error() string {
	return fmt.Sprintf("[GET /sdt/sdts/{id}][%d] getSDTById default  %+v", o._statusCode, o.Payload)
}
func (o *GetSDTByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetSDTByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
