// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetSDTHistoryByDeviceIDReader is a Reader for the GetSDTHistoryByDeviceID structure.
type GetSDTHistoryByDeviceIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetSDTHistoryByDeviceIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetSDTHistoryByDeviceIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetSDTHistoryByDeviceIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetSDTHistoryByDeviceIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetSDTHistoryByDeviceIDOK creates a GetSDTHistoryByDeviceIDOK with default headers values
func NewGetSDTHistoryByDeviceIDOK() *GetSDTHistoryByDeviceIDOK {
	return &GetSDTHistoryByDeviceIDOK{}
}

/* GetSDTHistoryByDeviceIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetSDTHistoryByDeviceIDOK struct {
	Payload *models.DeviceSDTHistoryPaginationResponse
}

func (o *GetSDTHistoryByDeviceIDOK) Error() string {
	return fmt.Sprintf("[GET /device/devices/{id}/historysdts][%d] getSdtHistoryByDeviceIdOK  %+v", 200, o.Payload)
}
func (o *GetSDTHistoryByDeviceIDOK) GetPayload() *models.DeviceSDTHistoryPaginationResponse {
	return o.Payload
}

func (o *GetSDTHistoryByDeviceIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DeviceSDTHistoryPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetSDTHistoryByDeviceIDTooManyRequests creates a GetSDTHistoryByDeviceIDTooManyRequests with default headers values
func NewGetSDTHistoryByDeviceIDTooManyRequests() *GetSDTHistoryByDeviceIDTooManyRequests {
	return &GetSDTHistoryByDeviceIDTooManyRequests{}
}

/* GetSDTHistoryByDeviceIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetSDTHistoryByDeviceIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetSDTHistoryByDeviceIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/devices/{id}/historysdts][%d] getSdtHistoryByDeviceIdTooManyRequests ", 429)
}

func (o *GetSDTHistoryByDeviceIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetSDTHistoryByDeviceIDDefault creates a GetSDTHistoryByDeviceIDDefault with default headers values
func NewGetSDTHistoryByDeviceIDDefault(code int) *GetSDTHistoryByDeviceIDDefault {
	return &GetSDTHistoryByDeviceIDDefault{
		_statusCode: code,
	}
}

/* GetSDTHistoryByDeviceIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetSDTHistoryByDeviceIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get SDT history by device Id default response
func (o *GetSDTHistoryByDeviceIDDefault) Code() int {
	return o._statusCode
}

func (o *GetSDTHistoryByDeviceIDDefault) Error() string {
	return fmt.Sprintf("[GET /device/devices/{id}/historysdts][%d] getSDTHistoryByDeviceId default  %+v", o._statusCode, o.Payload)
}
func (o *GetSDTHistoryByDeviceIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetSDTHistoryByDeviceIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
