// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetTopTalkersGraphReader is a Reader for the GetTopTalkersGraph structure.
type GetTopTalkersGraphReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetTopTalkersGraphReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetTopTalkersGraphOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetTopTalkersGraphTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetTopTalkersGraphDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetTopTalkersGraphOK creates a GetTopTalkersGraphOK with default headers values
func NewGetTopTalkersGraphOK() *GetTopTalkersGraphOK {
	return &GetTopTalkersGraphOK{}
}

/* GetTopTalkersGraphOK describes a response with status code 200, with default header values.

successful operation
*/
type GetTopTalkersGraphOK struct {
	Payload *models.GraphPlot
}

func (o *GetTopTalkersGraphOK) Error() string {
	return fmt.Sprintf("[GET /device/devices/{id}/topTalkersGraph][%d] getTopTalkersGraphOK  %+v", 200, o.Payload)
}
func (o *GetTopTalkersGraphOK) GetPayload() *models.GraphPlot {
	return o.Payload
}

func (o *GetTopTalkersGraphOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.GraphPlot)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTopTalkersGraphTooManyRequests creates a GetTopTalkersGraphTooManyRequests with default headers values
func NewGetTopTalkersGraphTooManyRequests() *GetTopTalkersGraphTooManyRequests {
	return &GetTopTalkersGraphTooManyRequests{}
}

/* GetTopTalkersGraphTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetTopTalkersGraphTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetTopTalkersGraphTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/devices/{id}/topTalkersGraph][%d] getTopTalkersGraphTooManyRequests ", 429)
}

func (o *GetTopTalkersGraphTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetTopTalkersGraphDefault creates a GetTopTalkersGraphDefault with default headers values
func NewGetTopTalkersGraphDefault(code int) *GetTopTalkersGraphDefault {
	return &GetTopTalkersGraphDefault{
		_statusCode: code,
	}
}

/* GetTopTalkersGraphDefault describes a response with status code -1, with default header values.

Error
*/
type GetTopTalkersGraphDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get top talkers graph default response
func (o *GetTopTalkersGraphDefault) Code() int {
	return o._statusCode
}

func (o *GetTopTalkersGraphDefault) Error() string {
	return fmt.Sprintf("[GET /device/devices/{id}/topTalkersGraph][%d] getTopTalkersGraph default  %+v", o._statusCode, o.Payload)
}
func (o *GetTopTalkersGraphDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetTopTalkersGraphDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
