// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetUpdateReasonListByConfigSourceIDReader is a Reader for the GetUpdateReasonListByConfigSourceID structure.
type GetUpdateReasonListByConfigSourceIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetUpdateReasonListByConfigSourceIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetUpdateReasonListByConfigSourceIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetUpdateReasonListByConfigSourceIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetUpdateReasonListByConfigSourceIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetUpdateReasonListByConfigSourceIDOK creates a GetUpdateReasonListByConfigSourceIDOK with default headers values
func NewGetUpdateReasonListByConfigSourceIDOK() *GetUpdateReasonListByConfigSourceIDOK {
	return &GetUpdateReasonListByConfigSourceIDOK{}
}

/* GetUpdateReasonListByConfigSourceIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetUpdateReasonListByConfigSourceIDOK struct {
	Payload *models.ConfigSourceUpdateReasonsPaginationResponse
}

func (o *GetUpdateReasonListByConfigSourceIDOK) Error() string {
	return fmt.Sprintf("[GET /setting/configsources/{id}/updatereasons][%d] getUpdateReasonListByConfigSourceIdOK  %+v", 200, o.Payload)
}
func (o *GetUpdateReasonListByConfigSourceIDOK) GetPayload() *models.ConfigSourceUpdateReasonsPaginationResponse {
	return o.Payload
}

func (o *GetUpdateReasonListByConfigSourceIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ConfigSourceUpdateReasonsPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetUpdateReasonListByConfigSourceIDTooManyRequests creates a GetUpdateReasonListByConfigSourceIDTooManyRequests with default headers values
func NewGetUpdateReasonListByConfigSourceIDTooManyRequests() *GetUpdateReasonListByConfigSourceIDTooManyRequests {
	return &GetUpdateReasonListByConfigSourceIDTooManyRequests{}
}

/* GetUpdateReasonListByConfigSourceIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetUpdateReasonListByConfigSourceIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetUpdateReasonListByConfigSourceIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/configsources/{id}/updatereasons][%d] getUpdateReasonListByConfigSourceIdTooManyRequests ", 429)
}

func (o *GetUpdateReasonListByConfigSourceIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetUpdateReasonListByConfigSourceIDDefault creates a GetUpdateReasonListByConfigSourceIDDefault with default headers values
func NewGetUpdateReasonListByConfigSourceIDDefault(code int) *GetUpdateReasonListByConfigSourceIDDefault {
	return &GetUpdateReasonListByConfigSourceIDDefault{
		_statusCode: code,
	}
}

/* GetUpdateReasonListByConfigSourceIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetUpdateReasonListByConfigSourceIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get update reason list by config source Id default response
func (o *GetUpdateReasonListByConfigSourceIDDefault) Code() int {
	return o._statusCode
}

func (o *GetUpdateReasonListByConfigSourceIDDefault) Error() string {
	return fmt.Sprintf("[GET /setting/configsources/{id}/updatereasons][%d] getUpdateReasonListByConfigSourceId default  %+v", o._statusCode, o.Payload)
}
func (o *GetUpdateReasonListByConfigSourceIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetUpdateReasonListByConfigSourceIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
