// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetUpdateReasonListByDataSourceIDReader is a Reader for the GetUpdateReasonListByDataSourceID structure.
type GetUpdateReasonListByDataSourceIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetUpdateReasonListByDataSourceIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetUpdateReasonListByDataSourceIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetUpdateReasonListByDataSourceIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetUpdateReasonListByDataSourceIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetUpdateReasonListByDataSourceIDOK creates a GetUpdateReasonListByDataSourceIDOK with default headers values
func NewGetUpdateReasonListByDataSourceIDOK() *GetUpdateReasonListByDataSourceIDOK {
	return &GetUpdateReasonListByDataSourceIDOK{}
}

/* GetUpdateReasonListByDataSourceIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetUpdateReasonListByDataSourceIDOK struct {
	Payload *models.DataSourceUpdateReasonsPaginationResponse
}

func (o *GetUpdateReasonListByDataSourceIDOK) Error() string {
	return fmt.Sprintf("[GET /setting/datasources/{id}/updatereasons][%d] getUpdateReasonListByDataSourceIdOK  %+v", 200, o.Payload)
}
func (o *GetUpdateReasonListByDataSourceIDOK) GetPayload() *models.DataSourceUpdateReasonsPaginationResponse {
	return o.Payload
}

func (o *GetUpdateReasonListByDataSourceIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DataSourceUpdateReasonsPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetUpdateReasonListByDataSourceIDTooManyRequests creates a GetUpdateReasonListByDataSourceIDTooManyRequests with default headers values
func NewGetUpdateReasonListByDataSourceIDTooManyRequests() *GetUpdateReasonListByDataSourceIDTooManyRequests {
	return &GetUpdateReasonListByDataSourceIDTooManyRequests{}
}

/* GetUpdateReasonListByDataSourceIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetUpdateReasonListByDataSourceIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetUpdateReasonListByDataSourceIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/datasources/{id}/updatereasons][%d] getUpdateReasonListByDataSourceIdTooManyRequests ", 429)
}

func (o *GetUpdateReasonListByDataSourceIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetUpdateReasonListByDataSourceIDDefault creates a GetUpdateReasonListByDataSourceIDDefault with default headers values
func NewGetUpdateReasonListByDataSourceIDDefault(code int) *GetUpdateReasonListByDataSourceIDDefault {
	return &GetUpdateReasonListByDataSourceIDDefault{
		_statusCode: code,
	}
}

/* GetUpdateReasonListByDataSourceIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetUpdateReasonListByDataSourceIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get update reason list by data source Id default response
func (o *GetUpdateReasonListByDataSourceIDDefault) Code() int {
	return o._statusCode
}

func (o *GetUpdateReasonListByDataSourceIDDefault) Error() string {
	return fmt.Sprintf("[GET /setting/datasources/{id}/updatereasons][%d] getUpdateReasonListByDataSourceId default  %+v", o._statusCode, o.Payload)
}
func (o *GetUpdateReasonListByDataSourceIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetUpdateReasonListByDataSourceIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
