// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetWebsiteDataByGraphNameReader is a Reader for the GetWebsiteDataByGraphName structure.
type GetWebsiteDataByGraphNameReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetWebsiteDataByGraphNameReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetWebsiteDataByGraphNameOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetWebsiteDataByGraphNameTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetWebsiteDataByGraphNameDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetWebsiteDataByGraphNameOK creates a GetWebsiteDataByGraphNameOK with default headers values
func NewGetWebsiteDataByGraphNameOK() *GetWebsiteDataByGraphNameOK {
	return &GetWebsiteDataByGraphNameOK{}
}

/* GetWebsiteDataByGraphNameOK describes a response with status code 200, with default header values.

successful operation
*/
type GetWebsiteDataByGraphNameOK struct {
	Payload *models.GraphPlot
}

func (o *GetWebsiteDataByGraphNameOK) Error() string {
	return fmt.Sprintf("[GET /website/websites/{id}/graphs/{graphName}/data][%d] getWebsiteDataByGraphNameOK  %+v", 200, o.Payload)
}
func (o *GetWebsiteDataByGraphNameOK) GetPayload() *models.GraphPlot {
	return o.Payload
}

func (o *GetWebsiteDataByGraphNameOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.GraphPlot)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetWebsiteDataByGraphNameTooManyRequests creates a GetWebsiteDataByGraphNameTooManyRequests with default headers values
func NewGetWebsiteDataByGraphNameTooManyRequests() *GetWebsiteDataByGraphNameTooManyRequests {
	return &GetWebsiteDataByGraphNameTooManyRequests{}
}

/* GetWebsiteDataByGraphNameTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetWebsiteDataByGraphNameTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetWebsiteDataByGraphNameTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /website/websites/{id}/graphs/{graphName}/data][%d] getWebsiteDataByGraphNameTooManyRequests ", 429)
}

func (o *GetWebsiteDataByGraphNameTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetWebsiteDataByGraphNameDefault creates a GetWebsiteDataByGraphNameDefault with default headers values
func NewGetWebsiteDataByGraphNameDefault(code int) *GetWebsiteDataByGraphNameDefault {
	return &GetWebsiteDataByGraphNameDefault{
		_statusCode: code,
	}
}

/* GetWebsiteDataByGraphNameDefault describes a response with status code -1, with default header values.

Error
*/
type GetWebsiteDataByGraphNameDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get website data by graph name default response
func (o *GetWebsiteDataByGraphNameDefault) Code() int {
	return o._statusCode
}

func (o *GetWebsiteDataByGraphNameDefault) Error() string {
	return fmt.Sprintf("[GET /website/websites/{id}/graphs/{graphName}/data][%d] getWebsiteDataByGraphName default  %+v", o._statusCode, o.Payload)
}
func (o *GetWebsiteDataByGraphNameDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetWebsiteDataByGraphNameDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
