// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetWebsiteGroupByIDReader is a Reader for the GetWebsiteGroupByID structure.
type GetWebsiteGroupByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetWebsiteGroupByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetWebsiteGroupByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetWebsiteGroupByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetWebsiteGroupByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetWebsiteGroupByIDOK creates a GetWebsiteGroupByIDOK with default headers values
func NewGetWebsiteGroupByIDOK() *GetWebsiteGroupByIDOK {
	return &GetWebsiteGroupByIDOK{}
}

/* GetWebsiteGroupByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetWebsiteGroupByIDOK struct {
	Payload *models.WebsiteGroup
}

func (o *GetWebsiteGroupByIDOK) Error() string {
	return fmt.Sprintf("[GET /website/groups/{id}][%d] getWebsiteGroupByIdOK  %+v", 200, o.Payload)
}
func (o *GetWebsiteGroupByIDOK) GetPayload() *models.WebsiteGroup {
	return o.Payload
}

func (o *GetWebsiteGroupByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.WebsiteGroup)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetWebsiteGroupByIDTooManyRequests creates a GetWebsiteGroupByIDTooManyRequests with default headers values
func NewGetWebsiteGroupByIDTooManyRequests() *GetWebsiteGroupByIDTooManyRequests {
	return &GetWebsiteGroupByIDTooManyRequests{}
}

/* GetWebsiteGroupByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetWebsiteGroupByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetWebsiteGroupByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /website/groups/{id}][%d] getWebsiteGroupByIdTooManyRequests ", 429)
}

func (o *GetWebsiteGroupByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetWebsiteGroupByIDDefault creates a GetWebsiteGroupByIDDefault with default headers values
func NewGetWebsiteGroupByIDDefault(code int) *GetWebsiteGroupByIDDefault {
	return &GetWebsiteGroupByIDDefault{
		_statusCode: code,
	}
}

/* GetWebsiteGroupByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetWebsiteGroupByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get website group by Id default response
func (o *GetWebsiteGroupByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetWebsiteGroupByIDDefault) Error() string {
	return fmt.Sprintf("[GET /website/groups/{id}][%d] getWebsiteGroupById default  %+v", o._statusCode, o.Payload)
}
func (o *GetWebsiteGroupByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetWebsiteGroupByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
