// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// PatchDefaultDashboardReader is a Reader for the PatchDefaultDashboard structure.
type PatchDefaultDashboardReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PatchDefaultDashboardReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPatchDefaultDashboardOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewPatchDefaultDashboardTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewPatchDefaultDashboardDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPatchDefaultDashboardOK creates a PatchDefaultDashboardOK with default headers values
func NewPatchDefaultDashboardOK() *PatchDefaultDashboardOK {
	return &PatchDefaultDashboardOK{}
}

/* PatchDefaultDashboardOK describes a response with status code 200, with default header values.

successful operation
*/
type PatchDefaultDashboardOK struct {
	Payload interface{}
}

func (o *PatchDefaultDashboardOK) Error() string {
	return fmt.Sprintf("[PATCH /setting/userdata/{id}][%d] patchDefaultDashboardOK  %+v", 200, o.Payload)
}
func (o *PatchDefaultDashboardOK) GetPayload() interface{} {
	return o.Payload
}

func (o *PatchDefaultDashboardOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPatchDefaultDashboardTooManyRequests creates a PatchDefaultDashboardTooManyRequests with default headers values
func NewPatchDefaultDashboardTooManyRequests() *PatchDefaultDashboardTooManyRequests {
	return &PatchDefaultDashboardTooManyRequests{}
}

/* PatchDefaultDashboardTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type PatchDefaultDashboardTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *PatchDefaultDashboardTooManyRequests) Error() string {
	return fmt.Sprintf("[PATCH /setting/userdata/{id}][%d] patchDefaultDashboardTooManyRequests ", 429)
}

func (o *PatchDefaultDashboardTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewPatchDefaultDashboardDefault creates a PatchDefaultDashboardDefault with default headers values
func NewPatchDefaultDashboardDefault(code int) *PatchDefaultDashboardDefault {
	return &PatchDefaultDashboardDefault{
		_statusCode: code,
	}
}

/* PatchDefaultDashboardDefault describes a response with status code -1, with default header values.

Error
*/
type PatchDefaultDashboardDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the patch default dashboard default response
func (o *PatchDefaultDashboardDefault) Code() int {
	return o._statusCode
}

func (o *PatchDefaultDashboardDefault) Error() string {
	return fmt.Sprintf("[PATCH /setting/userdata/{id}][%d] patchDefaultDashboard default  %+v", o._statusCode, o.Payload)
}
func (o *PatchDefaultDashboardDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *PatchDefaultDashboardDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
