// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// PatchDeviceDatasourceInstanceGroupByIDReader is a Reader for the PatchDeviceDatasourceInstanceGroupByID structure.
type PatchDeviceDatasourceInstanceGroupByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PatchDeviceDatasourceInstanceGroupByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPatchDeviceDatasourceInstanceGroupByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewPatchDeviceDatasourceInstanceGroupByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewPatchDeviceDatasourceInstanceGroupByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPatchDeviceDatasourceInstanceGroupByIDOK creates a PatchDeviceDatasourceInstanceGroupByIDOK with default headers values
func NewPatchDeviceDatasourceInstanceGroupByIDOK() *PatchDeviceDatasourceInstanceGroupByIDOK {
	return &PatchDeviceDatasourceInstanceGroupByIDOK{}
}

/* PatchDeviceDatasourceInstanceGroupByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type PatchDeviceDatasourceInstanceGroupByIDOK struct {
	Payload *models.DeviceDataSourceInstanceGroup
}

func (o *PatchDeviceDatasourceInstanceGroupByIDOK) Error() string {
	return fmt.Sprintf("[PATCH /device/devices/{deviceId}/devicedatasources/{deviceDsId}/groups/{id}][%d] patchDeviceDatasourceInstanceGroupByIdOK  %+v", 200, o.Payload)
}
func (o *PatchDeviceDatasourceInstanceGroupByIDOK) GetPayload() *models.DeviceDataSourceInstanceGroup {
	return o.Payload
}

func (o *PatchDeviceDatasourceInstanceGroupByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DeviceDataSourceInstanceGroup)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPatchDeviceDatasourceInstanceGroupByIDTooManyRequests creates a PatchDeviceDatasourceInstanceGroupByIDTooManyRequests with default headers values
func NewPatchDeviceDatasourceInstanceGroupByIDTooManyRequests() *PatchDeviceDatasourceInstanceGroupByIDTooManyRequests {
	return &PatchDeviceDatasourceInstanceGroupByIDTooManyRequests{}
}

/* PatchDeviceDatasourceInstanceGroupByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type PatchDeviceDatasourceInstanceGroupByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *PatchDeviceDatasourceInstanceGroupByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[PATCH /device/devices/{deviceId}/devicedatasources/{deviceDsId}/groups/{id}][%d] patchDeviceDatasourceInstanceGroupByIdTooManyRequests ", 429)
}

func (o *PatchDeviceDatasourceInstanceGroupByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewPatchDeviceDatasourceInstanceGroupByIDDefault creates a PatchDeviceDatasourceInstanceGroupByIDDefault with default headers values
func NewPatchDeviceDatasourceInstanceGroupByIDDefault(code int) *PatchDeviceDatasourceInstanceGroupByIDDefault {
	return &PatchDeviceDatasourceInstanceGroupByIDDefault{
		_statusCode: code,
	}
}

/* PatchDeviceDatasourceInstanceGroupByIDDefault describes a response with status code -1, with default header values.

Error
*/
type PatchDeviceDatasourceInstanceGroupByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the patch device datasource instance group by Id default response
func (o *PatchDeviceDatasourceInstanceGroupByIDDefault) Code() int {
	return o._statusCode
}

func (o *PatchDeviceDatasourceInstanceGroupByIDDefault) Error() string {
	return fmt.Sprintf("[PATCH /device/devices/{deviceId}/devicedatasources/{deviceDsId}/groups/{id}][%d] patchDeviceDatasourceInstanceGroupById default  %+v", o._statusCode, o.Payload)
}
func (o *PatchDeviceDatasourceInstanceGroupByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *PatchDeviceDatasourceInstanceGroupByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
