// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// PatchDeviceGroupDatasourceAlertSettingReader is a Reader for the PatchDeviceGroupDatasourceAlertSetting structure.
type PatchDeviceGroupDatasourceAlertSettingReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PatchDeviceGroupDatasourceAlertSettingReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPatchDeviceGroupDatasourceAlertSettingOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewPatchDeviceGroupDatasourceAlertSettingTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewPatchDeviceGroupDatasourceAlertSettingDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPatchDeviceGroupDatasourceAlertSettingOK creates a PatchDeviceGroupDatasourceAlertSettingOK with default headers values
func NewPatchDeviceGroupDatasourceAlertSettingOK() *PatchDeviceGroupDatasourceAlertSettingOK {
	return &PatchDeviceGroupDatasourceAlertSettingOK{}
}

/* PatchDeviceGroupDatasourceAlertSettingOK describes a response with status code 200, with default header values.

successful operation
*/
type PatchDeviceGroupDatasourceAlertSettingOK struct {
	Payload *models.DeviceGroupDataSourceAlertConfig
}

func (o *PatchDeviceGroupDatasourceAlertSettingOK) Error() string {
	return fmt.Sprintf("[PATCH /device/groups/{deviceGroupId}/datasources/{dsId}/alertsettings][%d] patchDeviceGroupDatasourceAlertSettingOK  %+v", 200, o.Payload)
}
func (o *PatchDeviceGroupDatasourceAlertSettingOK) GetPayload() *models.DeviceGroupDataSourceAlertConfig {
	return o.Payload
}

func (o *PatchDeviceGroupDatasourceAlertSettingOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DeviceGroupDataSourceAlertConfig)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPatchDeviceGroupDatasourceAlertSettingTooManyRequests creates a PatchDeviceGroupDatasourceAlertSettingTooManyRequests with default headers values
func NewPatchDeviceGroupDatasourceAlertSettingTooManyRequests() *PatchDeviceGroupDatasourceAlertSettingTooManyRequests {
	return &PatchDeviceGroupDatasourceAlertSettingTooManyRequests{}
}

/* PatchDeviceGroupDatasourceAlertSettingTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type PatchDeviceGroupDatasourceAlertSettingTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *PatchDeviceGroupDatasourceAlertSettingTooManyRequests) Error() string {
	return fmt.Sprintf("[PATCH /device/groups/{deviceGroupId}/datasources/{dsId}/alertsettings][%d] patchDeviceGroupDatasourceAlertSettingTooManyRequests ", 429)
}

func (o *PatchDeviceGroupDatasourceAlertSettingTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewPatchDeviceGroupDatasourceAlertSettingDefault creates a PatchDeviceGroupDatasourceAlertSettingDefault with default headers values
func NewPatchDeviceGroupDatasourceAlertSettingDefault(code int) *PatchDeviceGroupDatasourceAlertSettingDefault {
	return &PatchDeviceGroupDatasourceAlertSettingDefault{
		_statusCode: code,
	}
}

/* PatchDeviceGroupDatasourceAlertSettingDefault describes a response with status code -1, with default header values.

Error
*/
type PatchDeviceGroupDatasourceAlertSettingDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the patch device group datasource alert setting default response
func (o *PatchDeviceGroupDatasourceAlertSettingDefault) Code() int {
	return o._statusCode
}

func (o *PatchDeviceGroupDatasourceAlertSettingDefault) Error() string {
	return fmt.Sprintf("[PATCH /device/groups/{deviceGroupId}/datasources/{dsId}/alertsettings][%d] patchDeviceGroupDatasourceAlertSetting default  %+v", o._statusCode, o.Payload)
}
func (o *PatchDeviceGroupDatasourceAlertSettingDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *PatchDeviceGroupDatasourceAlertSettingDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
