// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// PatchDeviceGroupDatasourceByIDReader is a Reader for the PatchDeviceGroupDatasourceByID structure.
type PatchDeviceGroupDatasourceByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PatchDeviceGroupDatasourceByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPatchDeviceGroupDatasourceByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewPatchDeviceGroupDatasourceByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewPatchDeviceGroupDatasourceByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPatchDeviceGroupDatasourceByIDOK creates a PatchDeviceGroupDatasourceByIDOK with default headers values
func NewPatchDeviceGroupDatasourceByIDOK() *PatchDeviceGroupDatasourceByIDOK {
	return &PatchDeviceGroupDatasourceByIDOK{}
}

/* PatchDeviceGroupDatasourceByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type PatchDeviceGroupDatasourceByIDOK struct {
	Payload *models.DeviceGroupDataSource
}

func (o *PatchDeviceGroupDatasourceByIDOK) Error() string {
	return fmt.Sprintf("[PATCH /device/groups/{deviceGroupId}/datasources/{id}][%d] patchDeviceGroupDatasourceByIdOK  %+v", 200, o.Payload)
}
func (o *PatchDeviceGroupDatasourceByIDOK) GetPayload() *models.DeviceGroupDataSource {
	return o.Payload
}

func (o *PatchDeviceGroupDatasourceByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DeviceGroupDataSource)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPatchDeviceGroupDatasourceByIDTooManyRequests creates a PatchDeviceGroupDatasourceByIDTooManyRequests with default headers values
func NewPatchDeviceGroupDatasourceByIDTooManyRequests() *PatchDeviceGroupDatasourceByIDTooManyRequests {
	return &PatchDeviceGroupDatasourceByIDTooManyRequests{}
}

/* PatchDeviceGroupDatasourceByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type PatchDeviceGroupDatasourceByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *PatchDeviceGroupDatasourceByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[PATCH /device/groups/{deviceGroupId}/datasources/{id}][%d] patchDeviceGroupDatasourceByIdTooManyRequests ", 429)
}

func (o *PatchDeviceGroupDatasourceByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewPatchDeviceGroupDatasourceByIDDefault creates a PatchDeviceGroupDatasourceByIDDefault with default headers values
func NewPatchDeviceGroupDatasourceByIDDefault(code int) *PatchDeviceGroupDatasourceByIDDefault {
	return &PatchDeviceGroupDatasourceByIDDefault{
		_statusCode: code,
	}
}

/* PatchDeviceGroupDatasourceByIDDefault describes a response with status code -1, with default header values.

Error
*/
type PatchDeviceGroupDatasourceByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the patch device group datasource by Id default response
func (o *PatchDeviceGroupDatasourceByIDDefault) Code() int {
	return o._statusCode
}

func (o *PatchDeviceGroupDatasourceByIDDefault) Error() string {
	return fmt.Sprintf("[PATCH /device/groups/{deviceGroupId}/datasources/{id}][%d] patchDeviceGroupDatasourceById default  %+v", o._statusCode, o.Payload)
}
func (o *PatchDeviceGroupDatasourceByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *PatchDeviceGroupDatasourceByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
