// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// NewPatchSDTByIDParams creates a new PatchSDTByIDParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPatchSDTByIDParams() *PatchSDTByIDParams {
	return &PatchSDTByIDParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPatchSDTByIDParamsWithTimeout creates a new PatchSDTByIDParams object
// with the ability to set a timeout on a request.
func NewPatchSDTByIDParamsWithTimeout(timeout time.Duration) *PatchSDTByIDParams {
	return &PatchSDTByIDParams{
		timeout: timeout,
	}
}

// NewPatchSDTByIDParamsWithContext creates a new PatchSDTByIDParams object
// with the ability to set a context for a request.
func NewPatchSDTByIDParamsWithContext(ctx context.Context) *PatchSDTByIDParams {
	return &PatchSDTByIDParams{
		Context: ctx,
	}
}

// NewPatchSDTByIDParamsWithHTTPClient creates a new PatchSDTByIDParams object
// with the ability to set a custom HTTPClient for a request.
func NewPatchSDTByIDParamsWithHTTPClient(client *http.Client) *PatchSDTByIDParams {
	return &PatchSDTByIDParams{
		HTTPClient: client,
	}
}

/* PatchSDTByIDParams contains all the parameters to send to the API endpoint
   for the patch SDT by Id operation.

   Typically these are written to a http.Request.
*/
type PatchSDTByIDParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body models.SDT

	// ID.
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the patch SDT by Id params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PatchSDTByIDParams) WithDefaults() *PatchSDTByIDParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the patch SDT by Id params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PatchSDTByIDParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := PatchSDTByIDParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the patch SDT by Id params
func (o *PatchSDTByIDParams) WithTimeout(timeout time.Duration) *PatchSDTByIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the patch SDT by Id params
func (o *PatchSDTByIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the patch SDT by Id params
func (o *PatchSDTByIDParams) WithContext(ctx context.Context) *PatchSDTByIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the patch SDT by Id params
func (o *PatchSDTByIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the patch SDT by Id params
func (o *PatchSDTByIDParams) WithHTTPClient(client *http.Client) *PatchSDTByIDParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the patch SDT by Id params
func (o *PatchSDTByIDParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the patch SDT by Id params
func (o *PatchSDTByIDParams) WithUserAgent(userAgent *string) *PatchSDTByIDParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the patch SDT by Id params
func (o *PatchSDTByIDParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the patch SDT by Id params
func (o *PatchSDTByIDParams) WithBody(body models.SDT) *PatchSDTByIDParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the patch SDT by Id params
func (o *PatchSDTByIDParams) SetBody(body models.SDT) {
	o.Body = body
}

// WithID adds the id to the patch SDT by Id params
func (o *PatchSDTByIDParams) WithID(id string) *PatchSDTByIDParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the patch SDT by Id params
func (o *PatchSDTByIDParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *PatchSDTByIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
