// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// TestAWSAccountReader is a Reader for the TestAWSAccount structure.
type TestAWSAccountReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *TestAWSAccountReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewTestAWSAccountOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewTestAWSAccountTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewTestAWSAccountDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewTestAWSAccountOK creates a TestAWSAccountOK with default headers values
func NewTestAWSAccountOK() *TestAWSAccountOK {
	return &TestAWSAccountOK{}
}

/* TestAWSAccountOK describes a response with status code 200, with default header values.

successful operation
*/
type TestAWSAccountOK struct {
	Payload models.RestCloudOkPermissionsV3
}

func (o *TestAWSAccountOK) Error() string {
	return fmt.Sprintf("[POST /aws/functions/testAccount][%d] testAWSAccountOK  %+v", 200, o.Payload)
}
func (o *TestAWSAccountOK) GetPayload() models.RestCloudOkPermissionsV3 {
	return o.Payload
}

func (o *TestAWSAccountOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewTestAWSAccountTooManyRequests creates a TestAWSAccountTooManyRequests with default headers values
func NewTestAWSAccountTooManyRequests() *TestAWSAccountTooManyRequests {
	return &TestAWSAccountTooManyRequests{}
}

/* TestAWSAccountTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type TestAWSAccountTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *TestAWSAccountTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /aws/functions/testAccount][%d] testAWSAccountTooManyRequests ", 429)
}

func (o *TestAWSAccountTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewTestAWSAccountDefault creates a TestAWSAccountDefault with default headers values
func NewTestAWSAccountDefault(code int) *TestAWSAccountDefault {
	return &TestAWSAccountDefault{
		_statusCode: code,
	}
}

/* TestAWSAccountDefault describes a response with status code -1, with default header values.

Error
*/
type TestAWSAccountDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the test a w s account default response
func (o *TestAWSAccountDefault) Code() int {
	return o._statusCode
}

func (o *TestAWSAccountDefault) Error() string {
	return fmt.Sprintf("[POST /aws/functions/testAccount][%d] testAWSAccount default  %+v", o._statusCode, o.Payload)
}
func (o *TestAWSAccountDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *TestAWSAccountDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
