// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// NewTestAzureAccountParams creates a new TestAzureAccountParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewTestAzureAccountParams() *TestAzureAccountParams {
	return &TestAzureAccountParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewTestAzureAccountParamsWithTimeout creates a new TestAzureAccountParams object
// with the ability to set a timeout on a request.
func NewTestAzureAccountParamsWithTimeout(timeout time.Duration) *TestAzureAccountParams {
	return &TestAzureAccountParams{
		timeout: timeout,
	}
}

// NewTestAzureAccountParamsWithContext creates a new TestAzureAccountParams object
// with the ability to set a context for a request.
func NewTestAzureAccountParamsWithContext(ctx context.Context) *TestAzureAccountParams {
	return &TestAzureAccountParams{
		Context: ctx,
	}
}

// NewTestAzureAccountParamsWithHTTPClient creates a new TestAzureAccountParams object
// with the ability to set a custom HTTPClient for a request.
func NewTestAzureAccountParamsWithHTTPClient(client *http.Client) *TestAzureAccountParams {
	return &TestAzureAccountParams{
		HTTPClient: client,
	}
}

/* TestAzureAccountParams contains all the parameters to send to the API endpoint
   for the test azure account operation.

   Typically these are written to a http.Request.
*/
type TestAzureAccountParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body *models.RestAzureAccountTestV3

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the test azure account params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *TestAzureAccountParams) WithDefaults() *TestAzureAccountParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the test azure account params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *TestAzureAccountParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := TestAzureAccountParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the test azure account params
func (o *TestAzureAccountParams) WithTimeout(timeout time.Duration) *TestAzureAccountParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the test azure account params
func (o *TestAzureAccountParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the test azure account params
func (o *TestAzureAccountParams) WithContext(ctx context.Context) *TestAzureAccountParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the test azure account params
func (o *TestAzureAccountParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the test azure account params
func (o *TestAzureAccountParams) WithHTTPClient(client *http.Client) *TestAzureAccountParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the test azure account params
func (o *TestAzureAccountParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the test azure account params
func (o *TestAzureAccountParams) WithUserAgent(userAgent *string) *TestAzureAccountParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the test azure account params
func (o *TestAzureAccountParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the test azure account params
func (o *TestAzureAccountParams) WithBody(body *models.RestAzureAccountTestV3) *TestAzureAccountParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the test azure account params
func (o *TestAzureAccountParams) SetBody(body *models.RestAzureAccountTestV3) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *TestAzureAccountParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
