// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// TestGCPAccountReader is a Reader for the TestGCPAccount structure.
type TestGCPAccountReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *TestGCPAccountReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewTestGCPAccountOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewTestGCPAccountTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewTestGCPAccountDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewTestGCPAccountOK creates a TestGCPAccountOK with default headers values
func NewTestGCPAccountOK() *TestGCPAccountOK {
	return &TestGCPAccountOK{}
}

/* TestGCPAccountOK describes a response with status code 200, with default header values.

successful operation
*/
type TestGCPAccountOK struct {
	Payload models.RestCloudOkPermissionsV3
}

func (o *TestGCPAccountOK) Error() string {
	return fmt.Sprintf("[POST /gcp/functions/testAccount][%d] testGCPAccountOK  %+v", 200, o.Payload)
}
func (o *TestGCPAccountOK) GetPayload() models.RestCloudOkPermissionsV3 {
	return o.Payload
}

func (o *TestGCPAccountOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewTestGCPAccountTooManyRequests creates a TestGCPAccountTooManyRequests with default headers values
func NewTestGCPAccountTooManyRequests() *TestGCPAccountTooManyRequests {
	return &TestGCPAccountTooManyRequests{}
}

/* TestGCPAccountTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type TestGCPAccountTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *TestGCPAccountTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /gcp/functions/testAccount][%d] testGCPAccountTooManyRequests ", 429)
}

func (o *TestGCPAccountTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewTestGCPAccountDefault creates a TestGCPAccountDefault with default headers values
func NewTestGCPAccountDefault(code int) *TestGCPAccountDefault {
	return &TestGCPAccountDefault{
		_statusCode: code,
	}
}

/* TestGCPAccountDefault describes a response with status code -1, with default header values.

Error
*/
type TestGCPAccountDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the test g c p account default response
func (o *TestGCPAccountDefault) Code() int {
	return o._statusCode
}

func (o *TestGCPAccountDefault) Error() string {
	return fmt.Sprintf("[POST /gcp/functions/testAccount][%d] testGCPAccount default  %+v", o._statusCode, o.Payload)
}
func (o *TestGCPAccountDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *TestGCPAccountDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
