// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// UpdateAdminByIDReader is a Reader for the UpdateAdminByID structure.
type UpdateAdminByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateAdminByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateAdminByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateAdminByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateAdminByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateAdminByIDOK creates a UpdateAdminByIDOK with default headers values
func NewUpdateAdminByIDOK() *UpdateAdminByIDOK {
	return &UpdateAdminByIDOK{}
}

/* UpdateAdminByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateAdminByIDOK struct {
	Payload *models.Admin
}

func (o *UpdateAdminByIDOK) Error() string {
	return fmt.Sprintf("[PUT /setting/admins/{id}][%d] updateAdminByIdOK  %+v", 200, o.Payload)
}
func (o *UpdateAdminByIDOK) GetPayload() *models.Admin {
	return o.Payload
}

func (o *UpdateAdminByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Admin)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateAdminByIDTooManyRequests creates a UpdateAdminByIDTooManyRequests with default headers values
func NewUpdateAdminByIDTooManyRequests() *UpdateAdminByIDTooManyRequests {
	return &UpdateAdminByIDTooManyRequests{}
}

/* UpdateAdminByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateAdminByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *UpdateAdminByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /setting/admins/{id}][%d] updateAdminByIdTooManyRequests ", 429)
}

func (o *UpdateAdminByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateAdminByIDDefault creates a UpdateAdminByIDDefault with default headers values
func NewUpdateAdminByIDDefault(code int) *UpdateAdminByIDDefault {
	return &UpdateAdminByIDDefault{
		_statusCode: code,
	}
}

/* UpdateAdminByIDDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateAdminByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the update admin by Id default response
func (o *UpdateAdminByIDDefault) Code() int {
	return o._statusCode
}

func (o *UpdateAdminByIDDefault) Error() string {
	return fmt.Sprintf("[PUT /setting/admins/{id}][%d] updateAdminById default  %+v", o._statusCode, o.Payload)
}
func (o *UpdateAdminByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateAdminByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
