// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// UpdateDefaultDashboardReader is a Reader for the UpdateDefaultDashboard structure.
type UpdateDefaultDashboardReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateDefaultDashboardReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateDefaultDashboardOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateDefaultDashboardTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateDefaultDashboardDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateDefaultDashboardOK creates a UpdateDefaultDashboardOK with default headers values
func NewUpdateDefaultDashboardOK() *UpdateDefaultDashboardOK {
	return &UpdateDefaultDashboardOK{}
}

/* UpdateDefaultDashboardOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateDefaultDashboardOK struct {
	Payload interface{}
}

func (o *UpdateDefaultDashboardOK) Error() string {
	return fmt.Sprintf("[PUT /setting/userdata/{id}][%d] updateDefaultDashboardOK  %+v", 200, o.Payload)
}
func (o *UpdateDefaultDashboardOK) GetPayload() interface{} {
	return o.Payload
}

func (o *UpdateDefaultDashboardOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateDefaultDashboardTooManyRequests creates a UpdateDefaultDashboardTooManyRequests with default headers values
func NewUpdateDefaultDashboardTooManyRequests() *UpdateDefaultDashboardTooManyRequests {
	return &UpdateDefaultDashboardTooManyRequests{}
}

/* UpdateDefaultDashboardTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateDefaultDashboardTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *UpdateDefaultDashboardTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /setting/userdata/{id}][%d] updateDefaultDashboardTooManyRequests ", 429)
}

func (o *UpdateDefaultDashboardTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateDefaultDashboardDefault creates a UpdateDefaultDashboardDefault with default headers values
func NewUpdateDefaultDashboardDefault(code int) *UpdateDefaultDashboardDefault {
	return &UpdateDefaultDashboardDefault{
		_statusCode: code,
	}
}

/* UpdateDefaultDashboardDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateDefaultDashboardDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the update default dashboard default response
func (o *UpdateDefaultDashboardDefault) Code() int {
	return o._statusCode
}

func (o *UpdateDefaultDashboardDefault) Error() string {
	return fmt.Sprintf("[PUT /setting/userdata/{id}][%d] updateDefaultDashboard default  %+v", o._statusCode, o.Payload)
}
func (o *UpdateDefaultDashboardDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateDefaultDashboardDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
