// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// UpdateDeviceDatasourceInstanceGroupByIDReader is a Reader for the UpdateDeviceDatasourceInstanceGroupByID structure.
type UpdateDeviceDatasourceInstanceGroupByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateDeviceDatasourceInstanceGroupByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateDeviceDatasourceInstanceGroupByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateDeviceDatasourceInstanceGroupByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateDeviceDatasourceInstanceGroupByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateDeviceDatasourceInstanceGroupByIDOK creates a UpdateDeviceDatasourceInstanceGroupByIDOK with default headers values
func NewUpdateDeviceDatasourceInstanceGroupByIDOK() *UpdateDeviceDatasourceInstanceGroupByIDOK {
	return &UpdateDeviceDatasourceInstanceGroupByIDOK{}
}

/* UpdateDeviceDatasourceInstanceGroupByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateDeviceDatasourceInstanceGroupByIDOK struct {
	Payload *models.DeviceDataSourceInstanceGroup
}

func (o *UpdateDeviceDatasourceInstanceGroupByIDOK) Error() string {
	return fmt.Sprintf("[PUT /device/devices/{deviceId}/devicedatasources/{deviceDsId}/groups/{id}][%d] updateDeviceDatasourceInstanceGroupByIdOK  %+v", 200, o.Payload)
}
func (o *UpdateDeviceDatasourceInstanceGroupByIDOK) GetPayload() *models.DeviceDataSourceInstanceGroup {
	return o.Payload
}

func (o *UpdateDeviceDatasourceInstanceGroupByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DeviceDataSourceInstanceGroup)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateDeviceDatasourceInstanceGroupByIDTooManyRequests creates a UpdateDeviceDatasourceInstanceGroupByIDTooManyRequests with default headers values
func NewUpdateDeviceDatasourceInstanceGroupByIDTooManyRequests() *UpdateDeviceDatasourceInstanceGroupByIDTooManyRequests {
	return &UpdateDeviceDatasourceInstanceGroupByIDTooManyRequests{}
}

/* UpdateDeviceDatasourceInstanceGroupByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateDeviceDatasourceInstanceGroupByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *UpdateDeviceDatasourceInstanceGroupByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /device/devices/{deviceId}/devicedatasources/{deviceDsId}/groups/{id}][%d] updateDeviceDatasourceInstanceGroupByIdTooManyRequests ", 429)
}

func (o *UpdateDeviceDatasourceInstanceGroupByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateDeviceDatasourceInstanceGroupByIDDefault creates a UpdateDeviceDatasourceInstanceGroupByIDDefault with default headers values
func NewUpdateDeviceDatasourceInstanceGroupByIDDefault(code int) *UpdateDeviceDatasourceInstanceGroupByIDDefault {
	return &UpdateDeviceDatasourceInstanceGroupByIDDefault{
		_statusCode: code,
	}
}

/* UpdateDeviceDatasourceInstanceGroupByIDDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateDeviceDatasourceInstanceGroupByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the update device datasource instance group by Id default response
func (o *UpdateDeviceDatasourceInstanceGroupByIDDefault) Code() int {
	return o._statusCode
}

func (o *UpdateDeviceDatasourceInstanceGroupByIDDefault) Error() string {
	return fmt.Sprintf("[PUT /device/devices/{deviceId}/devicedatasources/{deviceDsId}/groups/{id}][%d] updateDeviceDatasourceInstanceGroupById default  %+v", o._statusCode, o.Payload)
}
func (o *UpdateDeviceDatasourceInstanceGroupByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateDeviceDatasourceInstanceGroupByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
