// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// UpdateDeviceGroupDatasourceByIDReader is a Reader for the UpdateDeviceGroupDatasourceByID structure.
type UpdateDeviceGroupDatasourceByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateDeviceGroupDatasourceByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateDeviceGroupDatasourceByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateDeviceGroupDatasourceByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateDeviceGroupDatasourceByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateDeviceGroupDatasourceByIDOK creates a UpdateDeviceGroupDatasourceByIDOK with default headers values
func NewUpdateDeviceGroupDatasourceByIDOK() *UpdateDeviceGroupDatasourceByIDOK {
	return &UpdateDeviceGroupDatasourceByIDOK{}
}

/* UpdateDeviceGroupDatasourceByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateDeviceGroupDatasourceByIDOK struct {
	Payload *models.DeviceGroupDataSource
}

func (o *UpdateDeviceGroupDatasourceByIDOK) Error() string {
	return fmt.Sprintf("[PUT /device/groups/{deviceGroupId}/datasources/{id}][%d] updateDeviceGroupDatasourceByIdOK  %+v", 200, o.Payload)
}
func (o *UpdateDeviceGroupDatasourceByIDOK) GetPayload() *models.DeviceGroupDataSource {
	return o.Payload
}

func (o *UpdateDeviceGroupDatasourceByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DeviceGroupDataSource)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateDeviceGroupDatasourceByIDTooManyRequests creates a UpdateDeviceGroupDatasourceByIDTooManyRequests with default headers values
func NewUpdateDeviceGroupDatasourceByIDTooManyRequests() *UpdateDeviceGroupDatasourceByIDTooManyRequests {
	return &UpdateDeviceGroupDatasourceByIDTooManyRequests{}
}

/* UpdateDeviceGroupDatasourceByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateDeviceGroupDatasourceByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *UpdateDeviceGroupDatasourceByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /device/groups/{deviceGroupId}/datasources/{id}][%d] updateDeviceGroupDatasourceByIdTooManyRequests ", 429)
}

func (o *UpdateDeviceGroupDatasourceByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateDeviceGroupDatasourceByIDDefault creates a UpdateDeviceGroupDatasourceByIDDefault with default headers values
func NewUpdateDeviceGroupDatasourceByIDDefault(code int) *UpdateDeviceGroupDatasourceByIDDefault {
	return &UpdateDeviceGroupDatasourceByIDDefault{
		_statusCode: code,
	}
}

/* UpdateDeviceGroupDatasourceByIDDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateDeviceGroupDatasourceByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the update device group datasource by Id default response
func (o *UpdateDeviceGroupDatasourceByIDDefault) Code() int {
	return o._statusCode
}

func (o *UpdateDeviceGroupDatasourceByIDDefault) Error() string {
	return fmt.Sprintf("[PUT /device/groups/{deviceGroupId}/datasources/{id}][%d] updateDeviceGroupDatasourceById default  %+v", o._statusCode, o.Payload)
}
func (o *UpdateDeviceGroupDatasourceByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateDeviceGroupDatasourceByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
