// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// NewUpdateEscalationChainByIDParams creates a new UpdateEscalationChainByIDParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateEscalationChainByIDParams() *UpdateEscalationChainByIDParams {
	return &UpdateEscalationChainByIDParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateEscalationChainByIDParamsWithTimeout creates a new UpdateEscalationChainByIDParams object
// with the ability to set a timeout on a request.
func NewUpdateEscalationChainByIDParamsWithTimeout(timeout time.Duration) *UpdateEscalationChainByIDParams {
	return &UpdateEscalationChainByIDParams{
		timeout: timeout,
	}
}

// NewUpdateEscalationChainByIDParamsWithContext creates a new UpdateEscalationChainByIDParams object
// with the ability to set a context for a request.
func NewUpdateEscalationChainByIDParamsWithContext(ctx context.Context) *UpdateEscalationChainByIDParams {
	return &UpdateEscalationChainByIDParams{
		Context: ctx,
	}
}

// NewUpdateEscalationChainByIDParamsWithHTTPClient creates a new UpdateEscalationChainByIDParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateEscalationChainByIDParamsWithHTTPClient(client *http.Client) *UpdateEscalationChainByIDParams {
	return &UpdateEscalationChainByIDParams{
		HTTPClient: client,
	}
}

/* UpdateEscalationChainByIDParams contains all the parameters to send to the API endpoint
   for the update escalation chain by Id operation.

   Typically these are written to a http.Request.
*/
type UpdateEscalationChainByIDParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body *models.EscalatingChain

	// ID.
	//
	// Format: int32
	ID int32

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update escalation chain by Id params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateEscalationChainByIDParams) WithDefaults() *UpdateEscalationChainByIDParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update escalation chain by Id params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateEscalationChainByIDParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := UpdateEscalationChainByIDParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the update escalation chain by Id params
func (o *UpdateEscalationChainByIDParams) WithTimeout(timeout time.Duration) *UpdateEscalationChainByIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update escalation chain by Id params
func (o *UpdateEscalationChainByIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update escalation chain by Id params
func (o *UpdateEscalationChainByIDParams) WithContext(ctx context.Context) *UpdateEscalationChainByIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update escalation chain by Id params
func (o *UpdateEscalationChainByIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update escalation chain by Id params
func (o *UpdateEscalationChainByIDParams) WithHTTPClient(client *http.Client) *UpdateEscalationChainByIDParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update escalation chain by Id params
func (o *UpdateEscalationChainByIDParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the update escalation chain by Id params
func (o *UpdateEscalationChainByIDParams) WithUserAgent(userAgent *string) *UpdateEscalationChainByIDParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the update escalation chain by Id params
func (o *UpdateEscalationChainByIDParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the update escalation chain by Id params
func (o *UpdateEscalationChainByIDParams) WithBody(body *models.EscalatingChain) *UpdateEscalationChainByIDParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update escalation chain by Id params
func (o *UpdateEscalationChainByIDParams) SetBody(body *models.EscalatingChain) {
	o.Body = body
}

// WithID adds the id to the update escalation chain by Id params
func (o *UpdateEscalationChainByIDParams) WithID(id int32) *UpdateEscalationChainByIDParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the update escalation chain by Id params
func (o *UpdateEscalationChainByIDParams) SetID(id int32) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateEscalationChainByIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt32(o.ID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
