// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// NewUpdateRecipientGroupByIDParams creates a new UpdateRecipientGroupByIDParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateRecipientGroupByIDParams() *UpdateRecipientGroupByIDParams {
	return &UpdateRecipientGroupByIDParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateRecipientGroupByIDParamsWithTimeout creates a new UpdateRecipientGroupByIDParams object
// with the ability to set a timeout on a request.
func NewUpdateRecipientGroupByIDParamsWithTimeout(timeout time.Duration) *UpdateRecipientGroupByIDParams {
	return &UpdateRecipientGroupByIDParams{
		timeout: timeout,
	}
}

// NewUpdateRecipientGroupByIDParamsWithContext creates a new UpdateRecipientGroupByIDParams object
// with the ability to set a context for a request.
func NewUpdateRecipientGroupByIDParamsWithContext(ctx context.Context) *UpdateRecipientGroupByIDParams {
	return &UpdateRecipientGroupByIDParams{
		Context: ctx,
	}
}

// NewUpdateRecipientGroupByIDParamsWithHTTPClient creates a new UpdateRecipientGroupByIDParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateRecipientGroupByIDParamsWithHTTPClient(client *http.Client) *UpdateRecipientGroupByIDParams {
	return &UpdateRecipientGroupByIDParams{
		HTTPClient: client,
	}
}

/* UpdateRecipientGroupByIDParams contains all the parameters to send to the API endpoint
   for the update recipient group by Id operation.

   Typically these are written to a http.Request.
*/
type UpdateRecipientGroupByIDParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body *models.RecipientGroup

	// ID.
	//
	// Format: int32
	ID int32

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update recipient group by Id params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateRecipientGroupByIDParams) WithDefaults() *UpdateRecipientGroupByIDParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update recipient group by Id params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateRecipientGroupByIDParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := UpdateRecipientGroupByIDParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the update recipient group by Id params
func (o *UpdateRecipientGroupByIDParams) WithTimeout(timeout time.Duration) *UpdateRecipientGroupByIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update recipient group by Id params
func (o *UpdateRecipientGroupByIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update recipient group by Id params
func (o *UpdateRecipientGroupByIDParams) WithContext(ctx context.Context) *UpdateRecipientGroupByIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update recipient group by Id params
func (o *UpdateRecipientGroupByIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update recipient group by Id params
func (o *UpdateRecipientGroupByIDParams) WithHTTPClient(client *http.Client) *UpdateRecipientGroupByIDParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update recipient group by Id params
func (o *UpdateRecipientGroupByIDParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the update recipient group by Id params
func (o *UpdateRecipientGroupByIDParams) WithUserAgent(userAgent *string) *UpdateRecipientGroupByIDParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the update recipient group by Id params
func (o *UpdateRecipientGroupByIDParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the update recipient group by Id params
func (o *UpdateRecipientGroupByIDParams) WithBody(body *models.RecipientGroup) *UpdateRecipientGroupByIDParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update recipient group by Id params
func (o *UpdateRecipientGroupByIDParams) SetBody(body *models.RecipientGroup) {
	o.Body = body
}

// WithID adds the id to the update recipient group by Id params
func (o *UpdateRecipientGroupByIDParams) WithID(id int32) *UpdateRecipientGroupByIDParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the update recipient group by Id params
func (o *UpdateRecipientGroupByIDParams) SetID(id int32) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateRecipientGroupByIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt32(o.ID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
