// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// UpdateRecipientGroupByIDReader is a Reader for the UpdateRecipientGroupByID structure.
type UpdateRecipientGroupByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateRecipientGroupByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateRecipientGroupByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateRecipientGroupByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateRecipientGroupByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateRecipientGroupByIDOK creates a UpdateRecipientGroupByIDOK with default headers values
func NewUpdateRecipientGroupByIDOK() *UpdateRecipientGroupByIDOK {
	return &UpdateRecipientGroupByIDOK{}
}

/* UpdateRecipientGroupByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateRecipientGroupByIDOK struct {
	Payload *models.RecipientGroup
}

func (o *UpdateRecipientGroupByIDOK) Error() string {
	return fmt.Sprintf("[PUT /setting/recipientgroups/{id}][%d] updateRecipientGroupByIdOK  %+v", 200, o.Payload)
}
func (o *UpdateRecipientGroupByIDOK) GetPayload() *models.RecipientGroup {
	return o.Payload
}

func (o *UpdateRecipientGroupByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.RecipientGroup)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateRecipientGroupByIDTooManyRequests creates a UpdateRecipientGroupByIDTooManyRequests with default headers values
func NewUpdateRecipientGroupByIDTooManyRequests() *UpdateRecipientGroupByIDTooManyRequests {
	return &UpdateRecipientGroupByIDTooManyRequests{}
}

/* UpdateRecipientGroupByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateRecipientGroupByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *UpdateRecipientGroupByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /setting/recipientgroups/{id}][%d] updateRecipientGroupByIdTooManyRequests ", 429)
}

func (o *UpdateRecipientGroupByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateRecipientGroupByIDDefault creates a UpdateRecipientGroupByIDDefault with default headers values
func NewUpdateRecipientGroupByIDDefault(code int) *UpdateRecipientGroupByIDDefault {
	return &UpdateRecipientGroupByIDDefault{
		_statusCode: code,
	}
}

/* UpdateRecipientGroupByIDDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateRecipientGroupByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the update recipient group by Id default response
func (o *UpdateRecipientGroupByIDDefault) Code() int {
	return o._statusCode
}

func (o *UpdateRecipientGroupByIDDefault) Error() string {
	return fmt.Sprintf("[PUT /setting/recipientgroups/{id}][%d] updateRecipientGroupById default  %+v", o._statusCode, o.Payload)
}
func (o *UpdateRecipientGroupByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateRecipientGroupByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
