// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// UpdateWebsiteGroupByIDReader is a Reader for the UpdateWebsiteGroupByID structure.
type UpdateWebsiteGroupByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateWebsiteGroupByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateWebsiteGroupByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateWebsiteGroupByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateWebsiteGroupByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateWebsiteGroupByIDOK creates a UpdateWebsiteGroupByIDOK with default headers values
func NewUpdateWebsiteGroupByIDOK() *UpdateWebsiteGroupByIDOK {
	return &UpdateWebsiteGroupByIDOK{}
}

/* UpdateWebsiteGroupByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateWebsiteGroupByIDOK struct {
	Payload *models.WebsiteGroup
}

func (o *UpdateWebsiteGroupByIDOK) Error() string {
	return fmt.Sprintf("[PUT /website/groups/{id}][%d] updateWebsiteGroupByIdOK  %+v", 200, o.Payload)
}
func (o *UpdateWebsiteGroupByIDOK) GetPayload() *models.WebsiteGroup {
	return o.Payload
}

func (o *UpdateWebsiteGroupByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.WebsiteGroup)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateWebsiteGroupByIDTooManyRequests creates a UpdateWebsiteGroupByIDTooManyRequests with default headers values
func NewUpdateWebsiteGroupByIDTooManyRequests() *UpdateWebsiteGroupByIDTooManyRequests {
	return &UpdateWebsiteGroupByIDTooManyRequests{}
}

/* UpdateWebsiteGroupByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateWebsiteGroupByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *UpdateWebsiteGroupByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /website/groups/{id}][%d] updateWebsiteGroupByIdTooManyRequests ", 429)
}

func (o *UpdateWebsiteGroupByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateWebsiteGroupByIDDefault creates a UpdateWebsiteGroupByIDDefault with default headers values
func NewUpdateWebsiteGroupByIDDefault(code int) *UpdateWebsiteGroupByIDDefault {
	return &UpdateWebsiteGroupByIDDefault{
		_statusCode: code,
	}
}

/* UpdateWebsiteGroupByIDDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateWebsiteGroupByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the update website group by Id default response
func (o *UpdateWebsiteGroupByIDDefault) Code() int {
	return o._statusCode
}

func (o *UpdateWebsiteGroupByIDDefault) Error() string {
	return fmt.Sprintf("[PUT /website/groups/{id}][%d] updateWebsiteGroupById default  %+v", o._statusCode, o.Payload)
}
func (o *UpdateWebsiteGroupByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateWebsiteGroupByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
