// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"bytes"
	"context"
	"encoding/json"
	"io"
	"io/ioutil"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/validate"
)

// AutoDiscoveryMethod auto discovery method
//
// swagger:discriminator AutoDiscoveryMethod name
type AutoDiscoveryMethod interface {
	runtime.Validatable
	runtime.ContextValidatable

	// The auto discovery method name.
	// The values can be ad_cim|ad_cloudwatch|ad_collector|ad_dummy|ad_ec2|ad_esx|ad_http|ad_ipmi|ad_jdbc|ad_jmx|ad_netapp|ad_pdh|ad_port|ad_script|ad_snmp|ad_wmi|ad_xen|ad_azurerediscache|ad_awsserviceregion|ad_awsec2reservedinstance|ad_awsec2reservedinstancecoverage|ad_awsecsservice|ad_awsec2scheduledevents|ad_azureserviceregion|ad_azuresubscription|ad_azurebackupjob|ad_azuresdk|ad_azurewebjob|ad_awsbillingreport|ad_awselasticache|ad_awsredshift|ad_azurebilling|ad_awslbtargetgroups|ad_gcpappengine|ad_gcpbilling|ad_awsvpntunnel|ad_gcpvpntunnel|ad_awsglobalwebacl|ad_gcplbbackendservice|ad_gcppubsubsubscription|ad_gcppubsubsnapshot|ad_azurereplicationjob|ad_azureexpressroutecircuitpeering|ad_awsapigatewaystage|ad_azureautomationaccountcertificate|ad_azurevngconnection|ad_azurewebappinstance|ad_azureappserviceenvironmentmultirolepool|ad_openmetrics|ad_awsmediaconnectoutput|ad_awsmediaconnectsource|ad_awswebaclwafv2|ad_saaso365sharepointsite|ad_awscognitoidentityproviders|ad_azureeabilling|ad_saaszoomplanusage|ad_saasstatus|ad_azuresynapse|ad_saasairbrake|ad_syntheticsselenium|ad_azurevirtualdesktopsessionhosts|ad_saaso365subscribedsku|ad_azuredimension|ad_azurecostmanagementdimensions|ad_saaso365servicehealth|ad_saaso365mailbox|ad_azurenetappvolumes|ad_azureloganalyticsworkspaces|ad_saaszoomstatus|ad_saassalesforcelicense|ad_saaszoomroom|ad_saaswebexlicenseusage|ad_azureloganalyticsreplicationjob|ad_paasjsonpath|ad_awsrabbitmqqueue|ad_awssagemakerendpointvariant|ad_awsroute53resolveripaddress
	// Required: true
	Name() string
	SetName(string)

	// AdditionalProperties in base type shoud be handled just like regular properties
	// At this moment, the base type property is pushed down to the subtype
}

type autoDiscoveryMethod struct {
	nameField string
}

// Name gets the name of this polymorphic type
func (m *autoDiscoveryMethod) Name() string {
	return "AutoDiscoveryMethod"
}

// SetName sets the name of this polymorphic type
func (m *autoDiscoveryMethod) SetName(val string) {
}

// UnmarshalAutoDiscoveryMethodSlice unmarshals polymorphic slices of AutoDiscoveryMethod
func UnmarshalAutoDiscoveryMethodSlice(reader io.Reader, consumer runtime.Consumer) ([]AutoDiscoveryMethod, error) {
	var elements []json.RawMessage
	if err := consumer.Consume(reader, &elements); err != nil {
		return nil, err
	}

	var result []AutoDiscoveryMethod
	for _, element := range elements {
		obj, err := unmarshalAutoDiscoveryMethod(element, consumer)
		if err != nil {
			return nil, err
		}
		result = append(result, obj)
	}
	return result, nil
}

// UnmarshalAutoDiscoveryMethod unmarshals polymorphic AutoDiscoveryMethod
func UnmarshalAutoDiscoveryMethod(reader io.Reader, consumer runtime.Consumer) (AutoDiscoveryMethod, error) {
	// we need to read this twice, so first into a buffer
	data, err := ioutil.ReadAll(reader)
	if err != nil {
		return nil, err
	}
	return unmarshalAutoDiscoveryMethod(data, consumer)
}

func unmarshalAutoDiscoveryMethod(data []byte, consumer runtime.Consumer) (AutoDiscoveryMethod, error) {
	buf := bytes.NewBuffer(data)
	buf2 := bytes.NewBuffer(data)

	// the first time this is read is to fetch the value of the name property.
	var getType struct {
		Name string `json:"name"`
	}
	if err := consumer.Consume(buf, &getType); err != nil {
		return nil, err
	}

	if err := validate.RequiredString("name", "body", getType.Name); err != nil {
		return nil, err
	}

	// The value of name is used to determine which type to create and unmarshal the data into
	switch getType.Name {
	case "AutoDiscoveryMethod":
		var result autoDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AwsCognitoIdentityProvidersDiscoveryMethodV3":
		var result AwsCognitoIdentityProvidersDiscoveryMethodV3
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AwsGlobalWebACLDiscoveryMethodV3":
		var result AwsGlobalWebACLDiscoveryMethodV3
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AwsRoute53ResolverIPAddressDiscoveryMethod":
		var result AwsRoute53ResolverIPAddressDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AwsSageMakerEndpointVariantMethod":
		var result AwsSageMakerEndpointVariantMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AwsVpnTunnelDiscoveryMethodV3":
		var result AwsVpnTunnelDiscoveryMethodV3
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AzureActiveDirectoryAppSecretDiscoveryMethod":
		var result AzureActiveDirectoryAppSecretDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AzureAppServiceEnvironmentMultiRolePoolDiscoverMethod":
		var result AzureAppServiceEnvironmentMultiRolePoolDiscoverMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AzureAutomationAccountCertificateDiscoveryMethod":
		var result AzureAutomationAccountCertificateDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AzureBackupJobDiscoveryMethod":
		var result AzureBackupJobDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AzureBackupProtectedItemBackupJobDiscoveryMethod":
		var result AzureBackupProtectedItemBackupJobDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AzureCostManagementDimensionsDiscoveryMethod":
		var result AzureCostManagementDimensionsDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AzureCostManagementSubscriptionsDiscoveryMethod":
		var result AzureCostManagementSubscriptionsDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AzureCostManagementTagsDiscoveryMethod":
		var result AzureCostManagementTagsDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AzureDimensionDiscoveryMethod":
		var result AzureDimensionDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AzureEABillingDiscoveryMethodV3":
		var result AzureEABillingDiscoveryMethodV3
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AzureExpressRouteCircuitPeeringDiscoveryMethod":
		var result AzureExpressRouteCircuitPeeringDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AzureLogAnalyticsReplicationJobDiscoveryMethod":
		var result AzureLogAnalyticsReplicationJobDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AzureLogAnalyticsWorkspacesDiscoveryMethod":
		var result AzureLogAnalyticsWorkspacesDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AzureNetAppVolumesDiscoveryMethod":
		var result AzureNetAppVolumesDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AzureRecoveryServiceRTODiscoveryMethod":
		var result AzureRecoveryServiceRTODiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AzureReplicationJobDiscoveryMethod":
		var result AzureReplicationJobDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AzureSynapseDiscoveryMethodV3":
		var result AzureSynapseDiscoveryMethodV3
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AzureVNGConnectionDiscoveryMethod":
		var result AzureVNGConnectionDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AzureVwanVpnConnectionMethod":
		var result AzureVwanVpnConnectionMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AzureWebAppInstanceDiscoveryMethod":
		var result AzureWebAppInstanceDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "AzureWebJobDiscoveryMethod":
		var result AzureWebJobDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "GcpAppEngineDiscoveryMethod":
		var result GcpAppEngineDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "GcpBillingBigQuerySourceDiscoveryMethodV3":
		var result GcpBillingBigQuerySourceDiscoveryMethodV3
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "GcpBillingDiscoveryMethodV3":
		var result GcpBillingDiscoveryMethodV3
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "GcpLBBackendServiceDiscoveryMethodV3":
		var result GcpLBBackendServiceDiscoveryMethodV3
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "GcpPubSubSnapshotDiscoveryMethodV3":
		var result GcpPubSubSnapshotDiscoveryMethodV3
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "GcpPubSubSubscriptionDiscoveryMethodV3":
		var result GcpPubSubSubscriptionDiscoveryMethodV3
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "GcpVpnTunnelDiscoveryMethodV3":
		var result GcpVpnTunnelDiscoveryMethodV3
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "OpenMetricDiscoveryMethod":
		var result OpenMetricDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "PaaSJsonPathDiscoveryMethod":
		var result PaaSJSONPathDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "RabbitMQQueueAutoDiscoveryMethod":
		var result RabbitMQQueueAutoDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "SaaSO365SharePointSiteDiscoveryMethod":
		var result SaaSO365SharePointSiteDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "SaaSSlackHealthDiscoveryMethod":
		var result SaaSSlackHealthDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "SaaSWebexLicenseDiscoveryMethod":
		var result SaaSWebexLicenseDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "SaaSZoomPlanUsageDiscoveryMethod":
		var result SaaSZoomPlanUsageDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "SaaSZoomStatusDiscoveryMethod":
		var result SaaSZoomStatusDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "SaasAirbrakeDiscoveryMethod":
		var result SaasAirbrakeDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "SaasO365MailboxDiscoveryMethod":
		var result SaasO365MailboxDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "SaasO365ServiceHealthDiscoveryMethod":
		var result SaasO365ServiceHealthDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "SaasO365SkusDiscoveryMethod":
		var result SaasO365SkusDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "SaasSalesforceLicenseDiscoveryMethod":
		var result SaasSalesforceLicenseDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "SaasStatusDiscoveryMethod":
		var result SaasStatusDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "SaasZoomRoomDiscoveryMethod":
		var result SaasZoomRoomDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "SyntheticsSeleniumAutoDiscoveryMethodV3":
		var result SyntheticsSeleniumAutoDiscoveryMethodV3
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_awsapigatewaystage":
		var result AwsAPIGatewayStageDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_awsbillingreport":
		var result AwsBillingReportDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_awsec2reservedinstance":
		var result AwsEC2ReservedInstanceDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_awsec2reservedinstancecoverage":
		var result AwsEC2ReservedInstanceCoverageDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_awsec2scheduledevents":
		var result EC2ScheduledEventAutoDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_awsecsservice":
		var result AwsEcsServiceDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_awselasticache":
		var result AwsElastiCacheDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_awslbtargetgroups":
		var result AwsLBTargetGroupDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_awsmediaconnectoutput":
		var result AwsMediaConnectOutputDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_awsmediaconnectsource":
		var result AwsMediaConnectSourceDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_awsredshift":
		var result AwsRedShiftDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_awsserviceregion":
		var result AwsServiceRegionDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_awswebaclwafv2":
		var result AwsWebACLWafV2DiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_azurebilling":
		var result AzureBillingDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_azurerediscache":
		var result AzureRedisCacheDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_azureserviceregion":
		var result AzureServiceRegionDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_azuresubscription":
		var result AzureSubscriptionDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_azurevirtualdesktopsessionhosts":
		var result AzureVirtualDesktopSessionHostsDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_cim":
		var result CIMAutoDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_cloudwatch":
		var result CloudWatchAutoDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_collector":
		var result CollectorAutoDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_dummy":
		var result DummyAutoDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_ec2":
		var result EC2AutoDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_esx":
		var result ESXAutoDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_http":
		var result HTTPAutoDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_ipmi":
		var result IPMIAutoDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_jdbc":
		var result JDBCAutoDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_jmx":
		var result JMXAutoDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_netapp":
		var result NetAppAutoDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_pdh":
		var result PDHAutoDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_port":
		var result PortAutoDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_script":
		var result ScriptAutoDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_sdkscript":
		var result SDKScriptDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_snmp":
		var result SNMPAutoDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_wmi":
		var result WMIAutoDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	case "ad_xen":
		var result XENAutoDiscoveryMethod
		if err := consumer.Consume(buf2, &result); err != nil {
			return nil, err
		}
		return &result, nil
	}
	return nil, errors.New(422, "invalid name value: %q", getType.Name)
}

// Validate validates this auto discovery method
func (m *autoDiscoveryMethod) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this auto discovery method based on context it is used
func (m *autoDiscoveryMethod) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}
